/**==========================================================================

	PC-8001 Device Emulator for Win32 Ver 1.10
	Copyright (C)1993-2010 H.Kanemoto

	This is a free software. You may copy or distribute
	it without any permissions. But there are NO WARRANTY
	of use. Entire risk of use is with you.

	External assembler functions for IBM-PC with VC++ 5.0
	last modified  Apr,4,1998.

;==========================================================================*/
#ifndef _N80_H_
#define _N80_H_
#include "../z80/z80.h"
#ifdef __cplusplus
extern "C"
{
#endif
#define export
	typedef const DWORD	CDWORD, * LPCDWORD;
	typedef const BYTE	CBYTE, * LPCBYTE;
/**--------------------------------------------------------------------------
 **		\
 **------------------------------------------------------------------------*/
typedef struct N80_tag {			// N80 Win32
	int		vtbl_vram20[20];		// DirectSurface VRAM offset table (20 Lines)
	int		vtbl_vram25[25];		// DirectSurface VRAM offset table (25 Lines) 
	LPBYTE	vram_addr;				// DirectSurface VRAM pointer
	DWORD	vram_lpitch;			// DirectSurface width pitch
	int		vram_pixcel_pitch;		// DirectSurface width pixcel pitch
	int		vram_vpitch[20];		// DirectSurface virtical pixcel pitch
	DWORD	vram_top_offset;		// DirectSurface top start line
	DWORD	vram_left_offset;		// DirectSurface left start line
	LPCBYTE	prime_palettes;			// primary palettes
	LPCBYTE	second_palettes;		// secondary paletts (interrace)
	LPCDWORD	prime_rgb_colors;	// primary rgb colors
	LPCDWORD	second_rgb_colors;	// seconday rgb colors (interrace)
	DWORD	cur_pix_rgb;			// current font rgb color
	DWORD	cur_pix_rgb2;			// current font rgb color (interrace)
	BYTE	cur_pix_rgb_pal;		// current font color palette no
	BYTE	cur_pix_rgb_pal2;		// current font color palette no (interrace)

	double	eff_hz;					// Z80Clock(Hz)
	double	sys_hz;					// Z80_Clock(Hz)
	int		flips;					// bԕ`
	double	lines_per_flip;			// ϕ`֍s
}	N80, *LPN80;
/**--------------------------------------------------------------------------
 **		O[oϐ
 **------------------------------------------------------------------------*/
extern N80	n80win32;

#ifdef __cplusplus
}	// extern "C"
#endif
#endif//_N80_H_
