/**--------------------------------------------------------------------------
 **
 **		NEC PC-8001 Emulator "N80" for Win32/DirectX
 **		--------------------------------------------
 **		Copyright (c) 1993-2010 H.Kanemoto
 **
 **		Main Window
 **
 **		Rev		Date		Descriptions
 **		-----	----------	-----------------------------------------------
 **		1.00	1996/06/27	porting DOS version on WinG
 **		1.20	1997/08/10	porting WinG version on Win32/DirectX
 **		1.30	1998/03/12	
 **		1.43	2007/09/01	XPΉ
 **		1.44	2009/12/15	Vista/7Ή
 **		1.51	2010/01/27	DirectSound OnlyɕύX
 **------------------------------------------------------------------------*/
#include "n80_form.h"
#include "n80_directx.h"
#include "../z80/z80_thread.h"
#include <stdio.h>
/**--------------------------------------------------------------------------
 **		O[oϐ
 **------------------------------------------------------------------------*/
extern n80_assay	*assay;
extern n80_directx	*dx;
extern z80_thread	*th;
/**--------------------------------------------------------------------------
 **		RXgN^^fXgN^
 **------------------------------------------------------------------------*/
n80_form::n80_form (HINSTANCE hInstance)
{
	mInstance = hInstance;
	mUseVideo =TRUE;		// Off-screen̎gp敪: Video
	mReqRestart = FALSE;	// Z80 thread ăX^[gv敪F Ȃ
	mLostDDS = FALSE;		// DirectDraw Surface敪F L
	::InitializeCriticalSection(&m_csec);
}

n80_form::~n80_form ()
{
	assay->outputLog(TEXT("ENTER ~n80_form"));
	if (m_hevt_sync != NULL) {
		::CloseHandle(m_hevt_sync);
		m_hevt_sync = NULL;
	}
	if (m_hevt_ack != NULL) {
		::CloseHandle(m_hevt_ack);
		m_hevt_ack = NULL;
	}
	::DeleteCriticalSection(&m_csec);
	assay->outputLog(TEXT("LEAVE ~n80_form"));
}
/**--------------------------------------------------------------------------
 **		Window
 **------------------------------------------------------------------------*/
BOOL
n80_form::create (
	LPCSTR clsname, LPCTSTR title,
	int x,  int y, int width, int height)
{
	static const TCHAR *rev[] = {
		TEXT(""), TEXT("A"), TEXT("B"), TEXT("C"), TEXT("D"), TEXT("E"), TEXT("F")
	};
	TCHAR             fileName[MAX_PATH+1];
	DWORD             size;
	BYTE*             pVersion;
	VS_FIXEDFILEINFO* pFileInfo;
	UINT              queryLen;
	 
	::GetModuleFileName(NULL, fileName, sizeof(fileName));
	 
	size = ::GetFileVersionInfoSize(fileName, NULL);
	pVersion = new BYTE[size];
	if (::GetFileVersionInfo(fileName, NULL, size, pVersion)) {
		::VerQueryValue(pVersion, TEXT("\\"), (void**)&pFileInfo, &queryLen);
		sprintf(fileName, TEXT( "%s [%d.%d.%d%s]"), title,
							HIWORD(pFileInfo->dwFileVersionMS),
							LOWORD(pFileInfo->dwFileVersionMS),
							HIWORD(pFileInfo->dwFileVersionLS),
							rev[LOWORD(pFileInfo->dwFileVersionLS)]);
	}
	delete[] pVersion;

	mWnd = ::CreateWindowEx (
		WS_EX_ACCEPTFILES,
		clsname,
		fileName,
		//WS_POPUP | WS_VISIBLE,
		WS_POPUP | WS_SYSMENU | WS_CAPTION | WS_VISIBLE,
		x, y, width, height,
		NULL,
		(HMENU) 0,
		getInstance(),
		0);

	if (mWnd == NULL)
		return FALSE;
	else {
		::SetWindowLong (mWnd, GWL_USERDATA, (long) this);
		return TRUE;
	}
}
/**--------------------------------------------------------------------------
 **		WndProc
 **------------------------------------------------------------------------*/
LRESULT
n80_form::defWndproc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	switch (msg)
	{
	case  WM_ACTIVATEAPP:			// AvP[VtH[JX
		assay->outputLog(TEXT("WM_ACTIVATEAPP"));
		OnAppActivate(wp);
		break;
	case  WM_USER + 1:				// Z80XbhJn
		start();
		break;
	case  WM_USER + 2:				// Z80XbhُI
		assay->outputLog(TEXT("WM_Z80ABORT"));
		halt((USHORT) wp, (USHORT) lp);
		break;
	case  WM_QUERYENDSESSION:		// Windows I𓾂悤ƂĂꍇB
		assay->outputLog(TEXT("WM_QUERYENDSESSION"));
		exit();						// N80I
		break;
	case WM_CLOSE:					// Window
		assay->outputLog(TEXT("WM_CLOSE"));
		exit();						// N80I
		::DestroyWindow(mWnd);
		break;
	case  WM_ERASEBKGND:
		if (OnEraseBkgnd((HDC) wp))
			return 1;
		break;
	case  WM_PAINT:
		OnPaint();
		break;
	case  WM_MOVE:
		dx->reaclcWindowRect();
		break;
	case WM_KEYDOWN:
		if (!(lp & 0x40000000)) {	// Ỏ
			OnKeyDown(wp);
		}
		break;
	case WM_KEYUP:
		switch (wp)
		{
		case VK_F6:		if (::GetKeyState(VK_SHIFT) < 0)
							dx->toggleShowSysInfo();
						else
							dump();
						break;
		case VK_F7:		preference();				break;
		case VK_F8:		dx->toggleMute();			break;
		case VK_F9:		if (::GetKeyState(VK_SHIFT) < 0)
							cmtsave();
						else
							chooser();					
						break;
		case VK_F11:	n80device.pcg_mode ^= 0x01;
						n80device.attr.invalid();	break;
		case VK_F12:	if (::GetKeyState(VK_SHIFT) < 0)
							change_screen();
						else
							reset();
						break;
		case VK_PAUSE:
#if _DEBUG
						reset();					break;
#endif
		case VK_END:	postMessage(WM_CLOSE, 0, 0);
						break;
		default:		OnKeyUp(wp);				break;
		}
		break;
	case WM_SYSCOMMAND:
		if (LOWORD(wp) == IDM_N80CONFIG)
			preference();
		else if (LOWORD(wp) == IDM_N80HELP)
			about();
		else
			return ::DefWindowProc(hwnd, msg, wp, lp);
		break;
	case  WM_ENDSESSION:	// VXeI̓AvP[VI
	case  WM_DESTROY:		// jꂽꍇAAvP[VI
		assay->outputLog(TEXT("WM_DESTROY"));
		::SetWindowLong(mWnd, GWL_USERDATA, (long) NULL);
		::PostQuitMessage(0);
		break;
	default:
		return  ::DefWindowProc(hwnd, msg, wp, lp);
	}
	return 0;
}
/**--------------------------------------------------------------------------
 **		POST Message
 **------------------------------------------------------------------------*/
int
n80_form::postMessage(UINT msg, WPARAM wp, LPARAM lp)
{
	return ::PostMessage(mWnd, msg, wp, lp);
}
/**--------------------------------------------------------------------------
 **		Windos`揈
 **------------------------------------------------------------------------*/
void
n80_form::OnPaint()
{
	PAINTSTRUCT	ps;
	HDC			hdc;

	hdc = ::BeginPaint (mWnd, &ps);
	if (th->getZ80Paused())
		OnDraw (hdc);
	::EndPaint (mWnd, &ps);
}

void
n80_form::OnDraw(HDC hdc)
{
	POINT	size;
	RECT	rect;
	int		xc, yc;

	// N80 logo^CyCg
	if (::GetClientRect (mWnd, &rect)) {
		size.x = rect.right - rect.left;
		size.y = rect.bottom - rect.top;
		xc  = size.x / mLogo.getWidth ();
		xc += size.x % mLogo.getWidth () ? 1 : 0;
		yc  = size.y / mLogo.getHeight ();
		yc += size.y % mLogo.getHeight () ? 1 : 0;
		for (int row = 0; row < yc; row ++) {
			for (int col = 0; col < xc; col ++) {
				int x, y;
				x = col * mLogo.getWidth ();
				y = row * mLogo.getHeight ();
				::StretchDIBits (hdc, x, y,
					mLogo.getWidth (), mLogo.getHeight (),
					0, 0,
					mLogo.getWidth (), mLogo.getHeight (),
					(CONST VOID *) mLogo.getBytes (),
					(CONST BITMAPINFO *) mLogo.getBmpinfo (),
					DIB_RGB_COLORS, SRCCOPY);
			}
		}
	}
}

BOOL
n80_form::OnEraseBkgnd(HDC hdc)
{
	POINT	size;
	RECT	rect;
	HBRUSH	hbr = ::CreateSolidBrush((COLORREF) 0);

	if (::GetClientRect(mWnd, &rect)) {
		size.x = rect.right - rect.left;
		size.y = rect.bottom - rect.top;
		::SetRect(&rect, 0, 0, size.x, size.y);
		::FillRect(hdc, &rect, hbr);
		::DeleteObject(hbr);
		return  TRUE;
	}
	return FALSE;
	return TRUE;
}

void
n80_form::ForceShowCursor() {
	int cnt = ::ShowCursor(TRUE);
	if (cnt < 0) {
		for (int i = cnt; i < 0; ++i)
			::ShowCursor(TRUE);
	}
}

void
n80_form::ForceHideCursor() {
	int cnt = ::ShowCursor(FALSE);
	if (cnt > 0) {
		for (int i = cnt; i > 0; ++i)
			::ShowCursor(FALSE);
	}
}

void
n80_form::ShowCursorFullScreen() {
	if (dx->getFullScreenMode())
		ForceShowCursor();
}

void
n80_form::HideCursorFullScreen() {
	if (dx->getFullScreenMode())
		ForceHideCursor();
}
