/**--------------------------------------------------------------------------
 **
 **		NEC PC-8001 Emulator "N80" for Win32/DirectX
 **		--------------------------------------------
 **		Copyright (c) 1993-2010 H.Kanemoto
 **
 **		Main Window
 **
 **		Rev		Date		Descriptions
 **		-----	----------	-----------------------------------------------
 **		1.00	1996/06/27	porting DOS version on WinG
 **		1.20	1997/08/10	porting WinG version on Win32/DirectX
 **		1.30	1998/03/12	
 **		1.43	2007/09/01	XPΉ
 **		1.44	2009/12/15	Vista/7Ή
 **		1.51	2010/01/27	DirectSound OnlyɕύX
 **------------------------------------------------------------------------*/
#ifndef  _N80_FORM_H_
#define  _N80_FORM_H_
#define	 _CRT_SECURE_NO_WARNINGS 1
#define  IDM_N80CONFIG	1
#define  IDM_N80HELP	2
#include <windows.h>
#include "n80.h"
#include "n80_assay.h"
#include "../PC-8001/PC-8001.h"
#include "../lib/icj_dib.h"
/**--------------------------------------------------------------------------
 **		Oϐ
 **------------------------------------------------------------------------*/
extern "C" {
extern Z80CPU		cpu;
extern N80DEVICE	n80device;
}
/**==========================================================================
 **		Main Form Class
 **========================================================================*/
class n80_form {
	//-----------------------------------------------------------------------
	//	NX֐
	//-----------------------------------------------------------------------
	public:
	static  BOOL				registerClass (HINSTANCE, HICON, HCURSOR, HBRUSH, LPCTSTR);
	static	int					messageLoop ();
	static	LRESULT CALLBACK	WndProc (HWND, UINT, WPARAM, LPARAM);
	//-----------------------------------------------------------------------
	//	oϐ
	//-----------------------------------------------------------------------
	private:
	HINSTANCE			mInstance;
	HWND				mWnd;
	icj_dib				mLogo;
	HPALETTE			mPal;
	BOOL				mUseVideo;		// Off-screen̎gp敪(Video/System memory)
	BOOL				mTenKeyless;	// eL[̂ȂL[{[hΉ
	LONG				m_hard_volume;	// default DirectSound Hardware Volume
	LONG				m_soft_volume;	// default DirectSound Software Volume
	BYTE				(*m_patt_buff) [8][256][8];		// [F][][dot]
	BYTE				(*m_fpatt_buff)[8][256][16];	// [F][][dot]
	TCHAR				mIniPath[512];
	BOOL				mReqRestart;	// Z80 thread ăX^[gv
	BOOL				mLostDDS;		// DirectDraw Surface/Z80 j
	HANDLE				m_hevt_sync;	// sync stop request event from primary thread
	HANDLE				m_hevt_ack;		// ack accept response event from z80 thread
	CRITICAL_SECTION	m_csec;
	//-----------------------------------------------------------------------
	//	RXgN^^fXgN^
	//-----------------------------------------------------------------------
	public:
						n80_form(HINSTANCE);
	virtual				~n80_form();
	//-----------------------------------------------------------------------
	//	J\bh
	//-----------------------------------------------------------------------
	HINSTANCE			getInstance() const { return mInstance; }
	HWND				getHWnd() const { return mWnd; }
	virtual BOOL		create(LPCSTR clsname, LPCTSTR title, 
								int x=CW_USEDEFAULT,  int y=CW_USEDEFAULT,
								int w=CW_USEDEFAULT, int h=CW_USEDEFAULT);
	virtual int			postMessage(UINT msg, WPARAM wp, LPARAM lp);
	BOOL				getTenKeyLess() const { return mTenKeyless; }
	void				setTenKeyLess(BOOL flag) { mTenKeyless = flag; initKeyb(); }
	virtual BOOL		init();
	void				prepareWindowMode(int width, int height);
	void				prepareFullScreenMode(int width, int height);
	//-----------------------------------------------------------------------
	//	J\bh
	//-----------------------------------------------------------------------
	protected:
	virtual LRESULT		defWndproc(HWND, UINT, WPARAM, LPARAM);
	//-----------------------------------------------------------------------
	//	N80\bh
	//-----------------------------------------------------------------------
	void				clearRAM();
	BOOL				loadROM();
	BOOL				loadBMP();
	BOOL				loadFont();
	void				loadProfile(LPCTSTR);
	void				saveProfile(LPCTSTR);
	BOOL				initProfile();
	void				initKeyb();
	//-----------------------------------------------------------------------
	//	t@CI
	//-----------------------------------------------------------------------
	void				chooser();
	BOOL				open_file(LPSTR);
	void				read_file(LPCSTR);
	void				cach_file(LPCSTR);
	void				membin_file(LPCSTR);
	//-----------------------------------------------------------------------
	//	CMTo̓t@CI
	//-----------------------------------------------------------------------
	void				cmtsave();
	BOOL				save_cmt_file(LPSTR);
	//-----------------------------------------------------------------------
	//	DUMPo
	//-----------------------------------------------------------------------
	void				dump();
	BOOL				save_file(LPSTR);
	void				write_file(LPCSTR);
	//-----------------------------------------------------------------------
	//	@\ݒ
	//-----------------------------------------------------------------------
	void				preference();
	//-----------------------------------------------------------------------
	//	wv
	//-----------------------------------------------------------------------
	void				about();
	//-----------------------------------------------------------------------
	//	}Vԑ
	//-----------------------------------------------------------------------
	void				start();
	void				restart();
	void				reset();
	void				exit();
	void				halt(USHORT, USHORT);
	void				change_screen();
	//-----------------------------------------------------------------------
	//	WindowCxgnh
	//-----------------------------------------------------------------------
	virtual void		OnAppActivate(BOOL);
	virtual void		OnPaint();
	virtual void		OnDraw(HDC);
	virtual BOOL		OnEraseBkgnd(HDC);
	virtual void		OnKeyDown(int vk);
	virtual void		OnKeyUp(int vk);
	virtual void		ForceShowCursor();
	virtual void		ForceHideCursor();
	virtual void		ShowCursorFullScreen();
	virtual void		HideCursorFullScreen();
};
/**==========================================================================
 **		ASM MODULE import ϐ^֐
 **========================================================================*/
extern "C" {
	//extern void		_blt_mmx();			// blt.asm
}
#endif //_N80_FORM_H_
