/**--------------------------------------------------------------------------
 **
 **		NEC PC-8001 Emulator "N80" for Win32/DirectX
 **		--------------------------------------------
 **		Copyright (c) 1993-2010 H.Kanemoto
 **
 **		Load N80/CMT Files
 **
 **		Rev		Date		Descriptions
 **		-----	----------	-----------------------------------------------
 **		1.00	1996/06/27	porting DOS version on WinG
 **		1.20	1997/08/10	porting WinG version on Win32/DirectX
 **		1.30	1998/03/12	
 **		1.43	2007/09/01	XPΉ
 **		1.44	2009/12/15	Vista/7Ή
 **		1.51	2010/01/27	DirectSound OnlyɕύX
 **------------------------------------------------------------------------*/
#include "n80_form.h"
#include "n80_directx.h"
#include "../pc-8001/pc-8001.h"
#include "../z80/z80_thread.h"
#include "../lib/icj_stream.h"
#include "../lib/icj_memory.h"
#include <string.h>
#include <crtdbg.h>
/**--------------------------------------------------------------------------
 **		O[oϐ
 **------------------------------------------------------------------------*/
extern z80_thread	*th;
extern n80_directx	*dx;
extern "C" {
	extern void __cdecl	_n80_mbwrite(USHORT Adr, BYTE v, DWORD* W);
}
/**--------------------------------------------------------------------------
 **		萔`
 **------------------------------------------------------------------------*/
#define  SP_VAL   0x7f3e
#define  PC_VAL   0xff3d
#define  STDSIZE  32576
#define  MAXSIZE  32768
/**--------------------------------------------------------------------------
 **		N80/CMT t@CI
 **------------------------------------------------------------------------*/
void
n80_form::chooser ()
{
	char	path_name[512];

	if (th->sync()) {
		dx->stop();
		ShowCursorFullScreen();
		::InvalidateRect(mWnd, NULL, TRUE);

		if (open_file(path_name)) {
			if (strstr(path_name, ".N80") || strstr(path_name, ".n80"))
				read_file(path_name);
			else if (strstr(path_name, ".CMT") || strstr(path_name, ".cmt"))
				cach_file(path_name);
			else if (strstr(path_name, ".BIN") || strstr(path_name, ".bin"))
				membin_file(path_name);
		}
		HideCursorFullScreen();
		::SetFocus(mWnd);
		n80device.attr.invalid();
		th->desync();
		dx->play();
	}
}
/**--------------------------------------------------------------------------
 **		N80/CMT t@CI
 **------------------------------------------------------------------------*/
BOOL
n80_form::open_file (LPSTR szPath)
{
	OPENFILENAME	ofn;
	char	szName[16];
	char	szCurDir[512];
	char	szFilter[] = TEXT("N80 ۸̧\0*.N80;*.CMT;*.BIN\0\0");

	::ZeroMemory(&ofn, sizeof(OPENFILENAME));
	::GetCurrentDirectory(sizeof (szCurDir), szCurDir);
	szName[0] = 0x00;
	lstrcpy(szPath, TEXT("*.n80;*.cmt;*.bin"));

	ofn.lStructSize			= sizeof(OPENFILENAME); 
	ofn.hwndOwner			= mWnd;
	ofn.hInstance			= NULL;
	ofn.lpstrFilter			= (const char *) szFilter;
	ofn.lpstrCustomFilter	= NULL; 
	ofn.nMaxCustFilter		= 0;
	ofn.nFilterIndex		= 0; 
	ofn.lpstrFile			= szPath;
	ofn.nMaxFile			= 512;
	ofn.lpstrFileTitle		= szName; 
	ofn.nMaxFileTitle		= sizeof(szName); 
	ofn.lpstrInitialDir		= szCurDir;
	ofn.lpstrTitle			= TEXT("N80 ̧ق̑I"); 
	ofn.Flags				= OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST; 
	ofn.nFileOffset			= 0; 
	ofn.nFileExtension		= 0; 
	ofn.lpstrDefExt			= TEXT("N80"); 
	ofn.lCustData			= 0; 
	ofn.lpfnHook			= NULL; 
	ofn.lpTemplateName		= NULL;

	return  ::GetOpenFileName(&ofn);
}
/**--------------------------------------------------------------------------
 **		N80/CMT t@Cǂݍ
 **------------------------------------------------------------------------*/
void
n80_form::read_file(LPCSTR path_name)
{
	icj_fstream	fs;
	DWORD		fsiz, i, W;
	USHORT		spval, addr;

	if (fs.open(path_name, TRUE)) {
		fsiz = fs.getSize();
		if (fsiz >= STDSIZE) {
			fsiz = (fsiz > MAXSIZE) ? MAXSIZE : fsiz;
			for (i = 0, addr = 0x8000; i < fsiz; ++i) {
				BYTE b;
				fs.read(&b, 1, 1);
				_n80_mbwrite(addr++, b, &W);
			}
			//fs.read(&n80device.mem._ram[0x8000], fsiz, 1);
			fs.seek(FILE_BEGIN, SP_VAL);
			fs.read(&spval, 2, 1);
			th->restart(PC_VAL, spval);
		}
		fs.close();
	}
}
/**--------------------------------------------------------------------------
 **		cacht@C
 **------------------------------------------------------------------------*/
void
n80_form::cach_file(LPCSTR path_name)
{
	icj_fstream	fs;

	if (fs.open(path_name, TRUE)) {
		if (n80device.cmt._buff) {
			xfree(n80device.cmt._buff);
			n80device.cmt._buff = NULL;
		}
		n80device.cmt._size = fs.getSize();
		n80device.cmt._buff = (LPBYTE) xmalloc(n80device.cmt._size);
		if (n80device.cmt._buff) {
			fs.read(n80device.cmt._buff, n80device.cmt._size, 1);
			n80device.cmt._index = 0;
		}
		fs.close();
	}
}
/**--------------------------------------------------------------------------
 **		BIN t@Cǂݍ
 **------------------------------------------------------------------------*/
void
n80_form::membin_file(LPCSTR path_name)
{
	icj_fstream	fs;
	DWORD		fsiz;

	if (fs.open(path_name, TRUE)) {
		fsiz = fs.getSize();
		if (fsiz <= 32*1024) {
			fs.read(n80device.mem.map._ram, fsiz, 1);
		}
		fs.close();
	}
}
/**--------------------------------------------------------------------------
 **		CMT ۑt@CI
 **------------------------------------------------------------------------*/
void
n80_form::cmtsave()
{
	if (th->sync()) {
		dx->stop();
		ShowCursorFullScreen();
		::InvalidateRect(mWnd, NULL, TRUE);

		if (save_cmt_file(n80device.save_cmt_path)) {
		}
		HideCursorFullScreen();
		::SetFocus(mWnd);
		n80device.attr.invalid();
		th->desync();
		dx->play();
	}
}
/**--------------------------------------------------------------------------
 **		ۑt@C_CAO
 **------------------------------------------------------------------------*/
BOOL
n80_form::save_cmt_file(LPSTR szPath)
{
	OPENFILENAME	ofn;
	char	szName[16];
	char	szCurDir[512];
	char	szFilter[] = TEXT("CMT o̧\0*.CMT\0\0");

	::ZeroMemory (&ofn, sizeof(OPENFILENAME));
	::GetCurrentDirectory (sizeof (szCurDir), szCurDir);
	szName[0] = 0x00;
	lstrcpy (szPath, TEXT("cassette"));

	ofn.lStructSize			= sizeof (OPENFILENAME); 
	ofn.hwndOwner			= mWnd;
	ofn.hInstance			= NULL;
	ofn.lpstrFilter			= (const char *) szFilter;
	ofn.lpstrCustomFilter	= NULL; 
	ofn.nMaxCustFilter		= 0;
	ofn.nFilterIndex		= 0; 
	ofn.lpstrFile			= szPath;
	ofn.nMaxFile			= 512;
	ofn.lpstrFileTitle		= szName; 
	ofn.nMaxFileTitle		= sizeof (szName); 
	ofn.lpstrInitialDir		= szCurDir;
	ofn.lpstrTitle			= TEXT("CMT ̧ق̕ۑI"); 
	ofn.Flags				= OFN_OVERWRITEPROMPT | OFN_EXPLORER;
	ofn.nFileOffset			= 0; 
	ofn.nFileExtension		= 0; 
	ofn.lpstrDefExt			= TEXT("CMT"); 
	ofn.lCustData			= 0; 
	ofn.lpfnHook			= NULL; 
	ofn.lpTemplateName		= NULL;

	return  ::GetSaveFileName (&ofn);
}
