/**--------------------------------------------------------------------------
 **
 **		NEC PC-8001 Emulator "N80" for Win32/DirectX
 **		--------------------------------------------
 **		Copyright (c) 1993-2010 H.Kanemoto
 **
 **		Preference
 **
 **		Rev		Date		Descriptions
 **		-----	----------	-----------------------------------------------
 **		1.00	1996/06/27	porting DOS version on WinG
 **		1.20	1997/08/10	porting WinG version on Win32/DirectX
 **		1.30	1998/03/12	
 **		1.43	2007/09/01	XPΉ
 **		1.44	2009/12/15	Vista/7Ή
 **		1.51	2010/01/27	DirectSound OnlyɕύX
 **------------------------------------------------------------------------*/
#include "n80_form.h"
#include "n80_directx.h"
#include "n80_assay.h"
#include "../z80/z80_thread.h"
#include "../res/resource.h"
#include <stdio.h>
#include <commctrl.h>
/**--------------------------------------------------------------------------
 **		O[oϐ
 **------------------------------------------------------------------------*/
extern n80_assay	*assay;
extern n80_form		*form;
extern z80_thread	*th;
extern n80_directx	*dx;
/**--------------------------------------------------------------------------
 **		W[ϐ
 **------------------------------------------------------------------------*/
static HWND			hSLDDma;
static HWND			hSLDGain;
static HWND			hSLDVol;
static HWND			hSLDAmp;
static HWND			hEDTDma;
static HWND			hEDTGain;
static HWND			hEDTVol;
static HWND			hEDTAmp;
static HWND			hCHKTen;
static HWND			hCHKNoW;
static HWND			hCHKSyc;
static HWND			hCHK720;
static HWND			hCHKTxt;
static HWND			hCHKInt;
/**--------------------------------------------------------------------------
 **		_CAO֐
 **------------------------------------------------------------------------*/
static BOOL CALLBACK
MyDlgProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	TCHAR buff[128];

	switch (msg) {
	case WM_INITDIALOG:
		hSLDDma  = ::GetDlgItem(hWnd, IDC_SLIDER1);
		hSLDGain = ::GetDlgItem(hWnd, IDC_SLIDER2);
		hSLDVol  = ::GetDlgItem(hWnd, IDC_SLIDER4);
		hSLDAmp  = ::GetDlgItem(hWnd, IDC_SLIDER5);
		hEDTDma  = ::GetDlgItem(hWnd, IDC_EDIT1);
		hEDTGain = ::GetDlgItem(hWnd, IDC_EDIT2);
		hEDTVol  = ::GetDlgItem(hWnd, IDC_EDIT4);
		hEDTAmp  = ::GetDlgItem(hWnd, IDC_EDIT5);
		hCHKTen  = ::GetDlgItem(hWnd, IDC_CHECKBOX1);
		hCHKNoW  = ::GetDlgItem(hWnd, IDC_CHECKBOX2);
		hCHKSyc  = ::GetDlgItem(hWnd, IDC_CHECKBOX3);
		hCHK720  = ::GetDlgItem(hWnd, IDC_CHECKBOX4);
		hCHKTxt  = ::GetDlgItem(hWnd, IDC_CHECKBOX5);
		hCHKInt  = ::GetDlgItem(hWnd, IDC_CHECKBOX6);

		::SendMessage(hWnd, WM_SETTEXT, 0, (LPARAM) TEXT("N80@\ݒ"));
		::SendMessage(hSLDDma,  TBM_SETRANGEMIN, 0,  0);	// From   0
		::SendMessage(hSLDDma,  TBM_SETRANGEMAX, 0, 100);	// To   100
		::SendMessage(hSLDGain, TBM_SETRANGEMIN, 0, 1);		// From   1
		::SendMessage(hSLDGain, TBM_SETRANGEMAX, 0, 40);	// to   40
		::SendMessage(hSLDVol,  TBM_SETRANGEMIN, 0, -100);	// From -100dB
		::SendMessage(hSLDVol,  TBM_SETRANGEMAX, 0, 0);		// to      0dB
		::SendMessage(hSLDAmp, TBM_SETRANGEMIN, 0, 1);		// From  15fps
		::SendMessage(hSLDAmp, TBM_SETRANGEMAX, 0, 18);		// to    60fps
		::SendMessage(hCHKTen, BM_SETCHECK, form->getTenKeyLess() ? BST_CHECKED : BST_UNCHECKED, 0);
		::SendMessage(hCHKSyc, BM_SETCHECK, dx->getSyncVBlank() ? BST_CHECKED : BST_UNCHECKED, 0);
		::SendMessage(hCHKNoW, BM_SETCHECK, th->getZ80NoWait() ? BST_CHECKED : BST_UNCHECKED, 0);
		::SendMessage(hCHK720, BM_SETCHECK, dx->getScreenSize() == 1 ? BST_CHECKED : BST_UNCHECKED, 0);
		::SendMessage(hCHKTxt, BM_SETCHECK, dx->getTxtOnDemand() ? BST_CHECKED : BST_UNCHECKED, 0);
		::SendMessage(hCHKInt, BM_SETCHECK, n80device.param.interlace ? BST_CHECKED : BST_UNCHECKED, 0);
		{
			::SendMessage(hSLDGain, TBM_SETPOS, 1, th->getDMALoadGain());
			sprintf_s(buff, sizeof(buff), "%d", th->getDMALoadGain());
			::SendMessage(hEDTGain,  WM_SETTEXT, 0, (LPARAM) buff);

			::SendMessage(hSLDDma, TBM_SETPOS, 1, n80device.dmac.dma_penalty_base);
			sprintf_s(buff, sizeof(buff), "%d", n80device.dmac.dma_penalty_base);
			::SendMessage(hEDTDma,  WM_SETTEXT, 0, (LPARAM) buff);

			::SendMessage(hSLDVol, TBM_SETPOS, 1, -99);
			::SendMessage(hSLDVol, TBM_SETPOS, 1, dx->getHardVolume() - 1);
			sprintf_s(buff, sizeof(buff), "%d", dx->getHardVolume() - 1);
			::SendMessage(hEDTVol,  WM_SETTEXT, 0, (LPARAM) buff);

			::SendMessage(hSLDAmp, TBM_SETPOS, 1, dx->getSoftVolume());
			sprintf_s(buff, sizeof(buff), "%d", dx->getSoftVolume());
			::SendMessage(hEDTAmp,  WM_SETTEXT, 0, (LPARAM) buff);
		}
		break;

	case WM_HSCROLL:
		if (hSLDDma == (HWND) lp) {
			switch (LOWORD(wp)) {
			case TB_ENDTRACK:
			case TB_THUMBTRACK:
				int hz = ::SendMessage(hSLDDma, TBM_GETPOS, 0, 0);
				sprintf_s(buff, sizeof(buff), "%d", hz);
				::SendMessage(hEDTDma, WM_SETTEXT, 0, (LPARAM) buff);
				break;
			}
		} else if (hSLDGain == (HWND) lp) {
			switch (LOWORD(wp)) {
			case TB_ENDTRACK:
			case TB_THUMBTRACK:
				int ms = ::SendMessage(hSLDGain, TBM_GETPOS, 0, 0);
				sprintf_s(buff, sizeof(buff), "%d", ms);
				::SendMessage(hEDTGain, WM_SETTEXT, 0, (LPARAM) buff);
				break;
			}
		} else if (hSLDVol == (HWND) lp) {
			switch (LOWORD(wp)) {
			case TB_ENDTRACK:
			case TB_THUMBTRACK:
				int fps = ::SendMessage(hSLDVol, TBM_GETPOS, 0, 0);
				sprintf_s(buff, sizeof(buff), "%d", fps);
				::SendMessage(hEDTVol, WM_SETTEXT, 0, (LPARAM) buff);
				break;
			}
		} else if (hSLDAmp == (HWND) lp) {
			switch (LOWORD(wp)) {
			case TB_ENDTRACK:
			case TB_THUMBTRACK:
				int fps = ::SendMessage(hSLDAmp, TBM_GETPOS, 0, 0);
				sprintf_s(buff, sizeof(buff), "%d", fps);
				::SendMessage(hEDTAmp, WM_SETTEXT, 0, (LPARAM) buff);
				break;
			}
		}
		break;

	case WM_COMMAND:
		switch (LOWORD(wp)) {
		case IDOK:
			{
				form->setTenKeyLess(::SendMessage(hCHKTen, BM_GETCHECK, 0, 0) == BST_CHECKED ? TRUE : FALSE);
				dx->setScreenSize(::SendMessage(hCHK720, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0);
				dx->setSyncVBlank(::SendMessage(hCHKSyc, BM_GETCHECK, 0, 0) == BST_CHECKED ? TRUE : FALSE);
				th->setZ80NoWait(::SendMessage(hCHKNoW, BM_GETCHECK, 0, 0) == BST_CHECKED ? TRUE : FALSE);
				dx->setTxtOnDemand(::SendMessage(hCHKTxt, BM_GETCHECK, 0, 0) == BST_CHECKED ? TRUE : FALSE);
				n80device.param.interlace = ::SendMessage(hCHKInt, BM_GETCHECK, 0, 0) == BST_CHECKED ? TRUE : FALSE;
				n80device.blt.chg_palette(n80device.param.interlace);
				int gain = ::SendMessage(hSLDGain, TBM_GETPOS, 0, 0);
				int load = ::SendMessage(hSLDDma,  TBM_GETPOS, 0, 0);
				int db = ::SendMessage(hSLDVol,  TBM_GETPOS, 0, 0);
				int ap = ::SendMessage(hSLDAmp,  TBM_GETPOS, 0, 0);
				n80device.dmac.dma_penalty_base = load;
				th->setDMALoadGain(gain);
				dx->setHardVolume(db);
				dx->setSoftVolume(ap);
			}
			::EndDialog(hWnd, 1);
			return TRUE;

		case IDCANCEL:
			::EndDialog(hWnd, 0);
			return TRUE;
		}
	}
	return FALSE;
}
/**--------------------------------------------------------------------------
 **		N80/CMT t@CI
 **------------------------------------------------------------------------*/
void
n80_form::preference()
{
	if (th->sync())
	{
		dx->stop();
		ShowCursorFullScreen();
		::SetFocus(mWnd);
		::InvalidateRect(mWnd, NULL, FALSE);
		DWORD result = ::DialogBox(mInstance, MAKEINTRESOURCE(IDD_DIALOG1), mWnd, MyDlgProc);
		if (result == 1) {
			m_hard_volume = dx->getHardVolume() - 1;
			m_soft_volume = dx->getSoftVolume();
			saveProfile(TEXT("Default"));
		}
		HideCursorFullScreen();
		::SetFocus(mWnd);
		n80device.attr.invalid();
		th->desync();
		dx->play();
	}
}
