/**--------------------------------------------------------------------------
 **
 **		NEC PC-8001 Emulator "N80" for Win32/DirectX
 **		--------------------------------------------
 **		Copyright (c) 1993-2010 H.Kanemoto
 **
 **		Rendering Thread
 **
 **		Rev		Date		Descriptions
 **		-----	----------	-----------------------------------------------
 **		1.52D	2010/10/30	ʃ_OThread
 **------------------------------------------------------------------------*/
#include "n80_render.h"
#include "../z80/z80_thread.h"
#include "../z80/z80.h"
#include <math.h>
/**--------------------------------------------------------------------------
 **		O[oϐ
 **------------------------------------------------------------------------*/
extern DWORD_PTR	affinity;
extern n80_assay	*assay;
extern n80_directx	*dx;
extern n80_form		*form;
extern z80_thread	*th;
extern "C" {
extern Z80CPU		cpu;
}
/**--------------------------------------------------------------------------
 **		RXgN^^fXgN^
 **------------------------------------------------------------------------*/
n80_render::n80_render() : icj_thread()
{
}

n80_render::~n80_render()
{
	assay->outputLog(TEXT("ENTER ~N80_render_thread"));
	if (isRunning()) {
		this->postMessage(WM_USER + 1, 0, 0);
		kill();
	}
	assay->outputLog(TEXT("LEAVE ~N80_render_thread"));
}
/**--------------------------------------------------------------------------
 **		Xbh[`{
 **------------------------------------------------------------------------*/
void
n80_render::enter()
{
	MSG msg;

	// Thread蓖ProcessorŒ肷
	if (!::SetThreadAffinityMask(::GetCurrentThread(), affinity & 8 ? 8 : 2)) {
		assay->outputLog(TEXT("Render ThreadŒ(%d)s"), affinity & 8 ? 8 : 2);
		if (!::SetThreadAffinityMask(::GetCurrentThread(), 1))
			assay->outputLog(TEXT("Render ThreadŒ(%d)s"), 1);
		else
			assay->outputLog(TEXT("Render ThreadŒ(%d)"), 1);
	} else
		assay->outputLog(TEXT("Render ThreadŒ(%d)"), affinity & 8 ? 8 : 2);

	UINT prev = ::timeGetTime();
	UINT interval = 0;
	UINT cnt = 0, lines = 0;
	int  flips = 0;
	double real_hz = 0.0, sys_hz = 0.0;

	for (;;) {
		::GetMessage(&msg, NULL, 0, 0);
		switch (msg.message) {
			case WM_USER + 1:	// IߎM
				return;
			case WM_USER + 2:	// `施ߎM
				while (::PeekMessage(&msg, NULL, WM_USER + 2, WM_USER + 2, PM_REMOVE))
					;

				++cnt;
				UINT current = ::timeGetTime();
				interval += (current - prev);
				prev = current;
				if (interval >= 1000) {
					// `摬x
					flips = (int) floor(((double) cnt * 1000.0 / (double) interval) + 0.5);
					// Z80 CPU NbN
					real_hz = ::InterlockedExchange(&cpu.Ts, 0);
					real_hz = (real_hz * 1000.0 / (double) interval) / 1000000.0;
					real_hz = floor((real_hz + 0.0005) * 1000.0) / 1000.0;
					// N80 _NbN
					sys_hz = th->getTs();
					sys_hz = (sys_hz * 1000.0 / (double) interval) / 1000000.0;
					sys_hz = floor((sys_hz + 0.0005) * 1000.0) / 1000.0;

					n80win32.eff_hz = real_hz;
					n80win32.sys_hz = sys_hz;
					n80win32.flips  = flips;
					n80win32.lines_per_flip = (int) floor(((double) lines / (double) cnt) + 0.05);

					cnt = 0;
					lines = 0;
					interval = 0;
				}
				lines += dx->transfer();
				break;
		}
	}
}
