;==============================================================================
;
;	PC-8001 Device Emulator for Win32 Ver 1.10
;	Copyright (C)1993-98 H.Kanemoto
;
;	This is a free software. You may copy or distribute
;	it without any permissions. But there are NO WARRANTY
;	of use. Entire risk of use is with you.
;
;	External assembler functions for IBM-PC with VC++ 5.0
;	last modified  Apr,4,1998.
;
__ATTRIB_ASM__	equ	1
;==============================================================================
include		n80.mac
public		__attrib
public		_attrchg
public		_textcach
public		_eval_attr
public		_n80_dmac_base		; DMA transfer interval rate
DMAFREQ		equ	40		; default DMA transfer interval rate
;==============================================================================
_DATA		segment
		even
_convfunc	dd	offset FLAT:_convmono
_convftbl	dd	offset FLAT:_convcolor
		dd	offset FLAT:_convmono
_n80_dmac_base	dw	DMAFREQ				; interval base value
_DMACYCLE	dw	DMAFREQ				; interval counter
_eval_attr	db	80 dup (?)			; evaluated attribute
_textcach	db	80 dup (?)			; text cach
_attrcach	db	40 dup (?)			; attr cach
_cur_line	db	24				; current attr line #
_attrchg	db	25 dup (0)			; last changed attr
_sortstk	db	22 dup (?)			; attr area sort stack
_headzero	db	0				; area start zero flag

_nextcolor	db	25 dup (0)			; attr effective color
_nextfunc	db	25 dup (0)			; attr effective func
_prevcolor	db	0				; previous color
_prevfunc	db	0				; previous func
_attc		db	00h,01h,04h,05h,02h,03h,06h,07h	; GRB to RGB order
_DATA		ends
;==============================================================================
_TEXT		segment
;------------------------------------------------------------------------------
;		BOOL	_attrib (void)	[z80_thread]
;------------------------------------------------------------------------------
		public	__attrib
__attrib	proc	near
		push	ebp
		mov	ebp,esp
		mov	eax,[ebp+8]		; eax = line

		push	esi			; dispatch input operations
		push	edi
		push	ebx

		mov	ebx,eax
		call	_attrib

		pop	ebx
		pop	edi
		pop	esi
		pop	ebp
		ret
__attrib	endp

		public	_attrib
_attrib		proc	near
;		dec	word ptr _DMACYCLE	; line display (DMA trans)
;		jz	@f			; interval wait
;		xor	eax,eax
;		ret
;@@:		mov	ax,_n80_dmac_base
;		mov	_DMACYCLE,ax
;		mov	bl,_cur_line		; set line # (0-24)
;		inc	bl
;		cmp	bl,25
;		jb	@f
;		xor	bl,bl
;@@:		mov	_cur_line,bl
;		movzx	ebx,bl
;		cmp	byte ptr _attrchg[ebx],0
;		jne	@f
;		xor	eax,eax
;		ret

;@@:		mov	byte ptr _attrchg[ebx],0
;		mov	esi,_vtbl_text[ebx*4]	; get text/attr offset
;		mov	edi,offset FLAT:_textcach
;		mov	ecx,30
;		mov	edx,4
;@@:		mov	eax,[esi]		; copy cur-attr to cach
;		mov	[edi],eax
;		add	esi,edx
;		add	edi,edx
;		loop	@b
		call	_eval_attrib
		mov	eax,1
		ret
_attrib		endp
;------------------------------------------------------------------------------
;		void	_eval_attrib (EBX:line)
;------------------------------------------------------------------------------
_eval_attrib	proc	near
		push	ebx			; save current line
		mov	ebp,_convfunc		; get attr convert function
		mov	al,_nextcolor[ebx]
		mov	_prevcolor,al
		mov	al,_nextfunc[ebx]
		mov	_prevfunc,al
		mov	esi,offset FLAT:_attrcach	; get attrib offset
		mov	edi,offset FLAT:_sortstk
		mov	ebx,offset FLAT:_eval_attr	;_vtbl_eval[ebx*4]
		call	_sortseg		; sort attr width
		mov	cx,5000h
		inc	esi			; N80 attribute c/f address
		inc	edi			; get _attrstk[1] pointer
		call	_movattr		; transfer attr to eval_tbl

		pop	ebx			; restore current line
		mov	eax,ebx			; save as arg value
		inc	bl
		cmp	bl,25
		jb	@f
		xor	ebx,ebx
@@:		mov	cl,_prevcolor
		mov	_nextcolor[ebx],cl
		mov	cl,_prevfunc
		mov	_nextfunc[ebx],cl
;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;	J[\\
;;;;;;;;;;;;;;;
		cmp	_n80_cur_row,al
		jne	@f
		cmp	byte ptr _n80_cur_blink,0
		je	@f
		cmp	byte ptr _n80_cur_enable,0
		je	@f
		mov	bl,_n80_cur_col
		movzx	ebx,bl
		xor	byte ptr _eval_attr[ebx],20h	; reverse
		or	byte ptr _eval_attr[ebx],07h	; color white
@@:		ret
_eval_attrib	endp
;------------------------------------------------------------------------------
;		void	_sortseg (void)
;------------------------------------------------------------------------------
_sortseg	proc	near			; sort attr area by ascent
		push	esi
		push	edi
		xor	cl,cl			; current attr width
		mov	byte ptr [edi],0
		mov	al,[esi]
		and	al,al
		setnz	byte ptr _headzero
sortloop:	mov	al,[esi]		; get N80 attr width
		cmp	al,[edi]
		je	@f			; skip if same width
		ja	addsort
		mov	edx,edi
comploop:	mov	ah,al			; sort operation
		xchg	ah,[edx]
		mov	[edx+1],ah
		dec	edx
		cmp	al,[edx]
		jb	comploop
		inc	edi
		jmp	short @f
addsort:	inc	edi
		mov	[edi],al
@@:		add	esi,2
		inc	cl
		cmp	cl,20
		jb	sortloop
		inc	edi
		mov	byte ptr [edi],0ffh
		pop	edi
		pop	esi
		ret
_sortseg	endp
;------------------------------------------------------------------------------
;		void	_movattr (void)
;------------------------------------------------------------------------------
_movattr	proc	near
		mov	ah,[edi]		; get 1st MAX
		cmp	byte ptr _headzero,0
		je	movloop
		mov	al,_prevfunc
		jmp	short @f
movloop:	mov	al,[esi]		; get N80 attribute c/f data
		add	esi,2
@@:		cmp	ah,ch			; MAX > width
		jbe	@f
		mov	ah,ch
@@:		call	ebp			; convert attribute
@@:		mov	[ebx],al
		inc	ebx
		inc	cl			; ++ current width
		cmp	cl,ah			; current width < MAX
		jb	@b
@@:		inc	edi			; get next MAX
		mov	ah,[edi]
		cmp	cl,ah
		je	@b
		cmp	cl,ch			; current < width
		jb	movloop
		ret
_movattr	endp
;------------------------------------------------------------------------------
;		AL	_convXXX (AL:n80attr)
;------------------------------------------------------------------------------
;	Plane Attribute Code (PAC) Format;	*ERG*RGB
;						 ||+ ȈՃOtBbN
;						 |+- ][h
;						 +-- [h
;------------------------------------------------------------------------------
		public	_convmono,_convcolor
;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;mN[h
;;;;;;;;;;;;;;;;
_convmono	proc	near			; N80 mono -> PAC
		push	ecx
		mov	cl,al
		and	al,07h			; pick out func bits
		mov	_prevfunc,al
		and	cl,80h			; test graph bits
		jz	@f
		or	al,10h			; move graph bit to bit4
@@:
		xor	ecx,ecx
		mov	cl,07h			; color (WHITE fixed)
		jmp	_chk_funcbit
;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;J[[h
;;;;;;;;;;;;;;;;
_convcolor	label	near			; N80 -> PAC
		test	al,08h
		jnz	@f
		and	al,07h			; @\w
		mov	_prevfunc,al
		or	al,_prevcolor
		jmp	short colormain
@@:		and	al,0f0h			; Fw
		mov	_prevcolor,al
;		mov	BYTE PTR _prevfunc,0
		or	al,_prevfunc
colormain:
		push	ecx
		xor	ecx,ecx
		mov	cl,al			; color (G,R,B order)
		and	cl,0e0h
		rol	cl,3
		mov	cl,_attc[ecx]		; color (R,G,B order)
_chk_funcbit:
		shr	al,1			; [h
		jnc	@f
		or	cl,40h
@@:		shr	al,2			; ][h
		jnc	@f
		or	cl,20h
@@:		shr	al,2			; ȈՃOt[h
		jnc	@f
		or	cl,10h

@@:		cmp	byte ptr _attr_reverse,0
		je	@f
		xor	cl,20h
@@:		mov	al,cl
		pop	ecx
		ret
_convmono	endp
;------------------------------------------------------------------------------
;		void	_chg_converter (ebx:mode)	[z80_thread]
;------------------------------------------------------------------------------
		public	_chg_converter
_chg_converter	proc	near
		mov	ebx,_convftbl[ebx*4]
		mov	_convfunc,ebx
		ret
_chg_converter	endp
;------------------------------------------------------------------------------
;		void	_attr_invalid ()		[z80_thread]
;------------------------------------------------------------------------------
		public	__attr_invalid
__attr_invalid	proc	near
		push	ebx
		push	ecx
		mov	ecx,25
		xor	ebx,ebx
@@:		mov	byte ptr _attrchg[ebx],1
		inc	ebx
		loop	@b
		pop	ecx
		pop	ebx
		ret
__attr_invalid	endp
;------------------------------------------------------------------------------
_TEXT		ends
;==============================================================================
		end
