;==============================================================================
;
;	PC-8001 Device Emulator for Win32 Ver 1.10
;	Copyright (C)1993-97 H.Kanemoto
;
;	This is a free software. You may copy or distribute
;	it without any permissions. But there are NO WARRANTY
;	of use. Entire risk of use is with you.
;
;	External assembler functions for IBM-PC with VC++ 5.0
;	last modified  Apr,6,1998.
;
__BEEP_ASM__	equ	1
;==============================================================================
include		n80.mac
EXTRN		__imp__Beep@8:NEAR
@BEEPLEN		equ	5
;==============================================================================
_DATA		segment
		even
_beep_on_ptr	dd	offset FLAT:_nt_beep_on_fn
_beep_on_dx_fn	dd	offset FLAT:_ds_beep_on

_beep_off_ptr	dd	offset FLAT:_nt_beep_off_fn
_beep_off_dx_fn	dd	offset FLAT:_ds_beep_off

_snd_on_ptr	dd	offset FLAT:_nt_snd_on_fn
_snd_on_dx_fn	dd	offset FLAT:_ds_snd_on_fn

_snd_off_ptr	dd	offset FLAT:_nt_snd_off_fn
_snd_off_dx_fn	dd	offset FLAT:_ds_snd_off_fn

_spker_on_ptr	dd	offset FLAT:_do_nothing
_spk_on_dx_fn	dd	offset FLAT:_ds_spk_on_fn

_spker_off_ptr	dd	offset FLAT:_nt_beep_off
_spk_off_dx_fn	dd	offset FLAT:_ds_spk_off_fn

_chg_freq_ptr	dd	offset FLAT:_nt_set_freq
_chg_dx_freq_fn	dd	offset FLAT:_ds_chg_freq

_ds_freq	dd	220			; adjusted DirectX freq
_nt_freq	dd	0			; adjusted Win32 Beep API freq
_req_freq_set	db	0			; 0:not changed	1:changed
_beepbusy	db	0			; 1:beep on	0:beep off
_soundbusy	db	0			; 1:pcg beep on 0:pcg beep off
_n80_snd_enable	db	1			; 1:enabled 	0:disabled

_DATA		ends
;==============================================================================
_TEXT		segment
;------------------------------------------------------------------------------
;		void	__beep_vtbl (int)
;------------------------------------------------------------------------------
		public	__beep_vtbl
__beep_vtbl	proc	near
		push	ebp
		mov	ebp,esp
		mov	eax,[ebp+8]		; eax = type (0:DirectSound, other:WinRing0 I/O)
		and	ax,ax
		jnz	@f

		mov	ebx,_chg_dx_freq_fn
		mov	_chg_freq_ptr,ebx

		mov	ebx,_beep_on_dx_fn
		mov	_beep_on_ptr,ebx
		mov	ebx,_beep_off_dx_fn
		mov	_beep_off_ptr,ebx

		mov	ebx,_snd_on_dx_fn
		mov	_snd_on_ptr,ebx
		mov	ebx,_snd_off_dx_fn
		mov	_snd_off_ptr,ebx

		mov	ebx,_spk_on_dx_fn
		mov	_spker_on_ptr,ebx
		mov	ebx,_spk_off_dx_fn
		mov	_spker_off_ptr,ebx
		pop	ebp
		ret

@@:		pop	ebp
		ret
__beep_vtbl	endp
;------------------------------------------------------------------------------
;		void	__silent ()
;------------------------------------------------------------------------------
		public	__silent
__silent	proc	near
		push	ebp
		push	esi
		push	edi
		push	ebx
		call	[_spker_off_ptr]
		mov	byte ptr _soundbusy,0
		mov	byte ptr _beepbusy,0
		pop	ebx
		pop	edi
		pop	esi
		pop	ebp
		ret
__silent	endp
;------------------------------------------------------------------------------
;		void	__unsilent ()
;------------------------------------------------------------------------------
		public	__unsilent
__unsilent	proc	near
		push	ebp
		push	esi
		push	edi
		push	ebx
		call	[_spker_on_ptr]
		pop	ebx
		pop	edi
		pop	esi
		pop	ebp
		ret
__unsilent	endp
;------------------------------------------------------------------------------
;		void	_enable_beep ()
;------------------------------------------------------------------------------
		public	__enable_beep
__enable_beep	proc	near
		push	ebp
		push	esi
		push	edi
		push	ebx
		mov	byte ptr _beepbusy,0
		mov	byte ptr _soundbusy,0
		xor	byte ptr _n80_snd_enable,1
		jne	@f
		call	[_spker_off_ptr]
		jmp	short L1
@@:		call	[_spker_on_ptr]
L1:		pop	ebx
		pop	edi
		pop	esi
		pop	ebp
		ret
__enable_beep	endp
;------------------------------------------------------------------------------
;		void	_beep_xxx (void)
;------------------------------------------------------------------------------
		public __n80_beep_on
__n80_beep_on	proc	near
		push	ebp
		push	esi
		push	edi
		push	ebx
		call	_beep_on
		pop		ebx
		pop		edi
		pop		esi
		pop		ebx
		ret
__n80_beep_on	endp
		public __n80_beep_off
__n80_beep_off	proc	near
		push	ebp
		push	esi
		push	edi
		push	ebx
		call	_beep_off
		pop		ebx
		pop		edi
		pop		esi
		pop		ebx
		ret
__n80_beep_off	endp

		public	_beep_on
_beep_on	proc	near
		cmp	byte ptr _n80_snd_enable,1
		je	@f
		ret
@@:		cmp	byte ptr _beepbusy,0	; check beep already on
		je	@f
		ret
@@:		mov	byte ptr _beepbusy,1
		jmp	[_beep_on_ptr]

		public	_beep_off
_beep_off	label	near
		cmp	byte ptr _beepbusy,1	; check beep already on
		je	@f
		ret
@@:		mov	byte ptr _beepbusy,0
		call	[_beep_off_ptr]
		ret
_beep_on	endp
;------------------------------------------------------------------------------
;		void	_sound_xxx (BX:freq)
;------------------------------------------------------------------------------
		public	_sound_on
_sound_on	proc	near
		cmp	byte ptr _n80_snd_enable,1
		jne	@f
		call	[_snd_on_ptr]
@@:		ret
		public	_sound_off
_sound_off	label	near
		call	[_snd_off_ptr]
		ret
_sound_on	endp
;------------------------------------------------------------------------------
;		void	_sound_freq_chg (BX:freq)
;------------------------------------------------------------------------------
		public	_sound_freq_chg
_sound_freq_chg	proc	near
		call	[_chg_freq_ptr]
		ret
_sound_freq_chg	endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;; W I N D O W S  N T  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;------------------------------------------------------------------------------
;		void	_nt_set_freq (BX:count)
;------------------------------------------------------------------------------
_nt_set_freq	proc	near
		movzx	ebx,bx
		xor	edx,edx
		mov	eax,4000000
		div	ebx			; freq = 4MHz / i8253 Counter
		mov	ebx,dword ptr _nt_freq	; get prev freq
		mov	dword ptr _nt_freq,eax	; set new freq

		cmp	byte ptr _n80_snd_enable,0
		je	@f
		cmp	byte ptr _beepbusy,1	; check beep is on
		je	@f
		cmp	byte ptr _soundbusy,0	; check pcg beep is off
		je	@f
		mov	byte ptr _req_freq_set,0
		cmp	eax,ebx					; same freq then ret
		jne		short t1
		ret
t1:		push	@BEEPLEN
		push	eax
		call	dword ptr __imp__Beep@8
		ret
@@:		mov	byte ptr _req_freq_set,1
		ret
_nt_set_freq	endp
;------------------------------------------------------------------------------
;		void	_nt_beep_on/off (void)
;------------------------------------------------------------------------------
_nt_beep_on_fn	proc	near
_nt_beep_on	label	near
		push	-1
		push	2400
		call	dword ptr __imp__Beep@8
		ret
_nt_beep_on_fn	endp

_nt_beep_off_fn	proc	near
		cmp	byte ptr _soundbusy,1	; check pcg beep waiting
		je	@f
		call	_nt_beep_off
		ret
@@:		mov	eax,dword ptr _nt_freq	; set pcg freq again
		push	@BEEPLEN
		push	eax
		call	dword ptr __imp__Beep@8
		ret
_nt_beep_off	label	near
		push	0
		push	2400
		call	dword ptr __imp__Beep@8
		ret
_nt_beep_off_fn	endp
;------------------------------------------------------------------------------
;		void	_nt_sound_on/off (void)
;------------------------------------------------------------------------------
_nt_snd_on_fn	proc	near
		cmp	byte ptr _soundbusy,0	; check pcg beep already on
		je	@f
		ret
@@:		mov	byte ptr _soundbusy,1
		cmp	byte ptr _beepbusy,0	; check beep already on
		je	@f
		ret
@@:		cmp	byte ptr _req_freq_set,0; check frequency has changed
		je	@f
		mov	byte ptr _req_freq_set,0
		mov	eax,dword ptr _nt_freq	; set pcg freq
		push	@BEEPLEN
		push	eax
		call	dword ptr __imp__Beep@8
@@:		ret
_nt_snd_on_fn	endp

_nt_snd_off_fn	proc	near
		cmp	byte ptr _soundbusy,1	; check pcg beep already off
		je	@f
		ret
@@:		mov	byte ptr _soundbusy,0
		cmp	byte ptr _beepbusy,1	; check beep is on
		je	@f
		mov	byte ptr _req_freq_set,1
		call	_nt_beep_off
		ret
@@:		call	_nt_beep_on
		ret
_nt_snd_off_fn	endp
;------------------------------------------------------------------------------
;		void	_do_nothing
;------------------------------------------------------------------------------
_do_nothing	proc	near
		ret
_do_nothing	endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;; D I R E C T  S O U N D  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;------------------------------------------------------------------------------
;		void	_ds_chg_freq (AX:freq)
;------------------------------------------------------------------------------
_ds_chg_freq	proc	near
		movzx	ebx,bx
		and	ebx,ebx		; prevent from zero div
		jne	@f
		mov	ebx,1		; vZʂ4800Hzȏɂ
@@:		xor	edx,edx
		mov	eax,4000000
		div	ebx			; freq = 4MHz / i8253 Counter
		cmp	eax,24			; MIN = 24Hz
		jae	@f
		mov	eax,24
@@:		cmp	eax,4800		; MAX = 4800Hz
		jbe	@f
		mov	eax,0			; 4800Hzȏ͏
@@:		mov	dword ptr _ds_freq,eax

		cmp	byte ptr _n80_snd_enable,0
		je	@f
		cmp	byte ptr _soundbusy,0	; check pcg beep is off
		je	@f
		mov	byte ptr _req_freq_set,0
		push	eax
		call	_ds_sound_on
		add	esp,4
		ret
@@:		mov	byte ptr _req_freq_set,1
		ret
_ds_chg_freq	endp
;------------------------------------------------------------------------------
;		void	_ds_sound_on/off (void)
;------------------------------------------------------------------------------
_ds_snd_on_fn	proc	near
		cmp	byte ptr _soundbusy,0	; check pcg beep already on
		je	@f
		ret
@@:		mov	byte ptr _soundbusy,1
		cmp	byte ptr _req_freq_set,0; check frequency has changed
		je	@f
		mov	byte ptr _req_freq_set,0
		mov	eax,dword ptr _ds_freq	; set pcg freq
		push	eax
		call	_ds_sound_on
		add	esp,4
@@:		ret
_ds_snd_on_fn	endp

_ds_snd_off_fn	proc	near
		cmp	byte ptr _soundbusy,1	; check pcg beep already off
		je	@f
		ret
@@:		mov	byte ptr _soundbusy,0
		mov	byte ptr _req_freq_set,1	; ĐWavv
		call	_ds_sound_off
		ret
_ds_snd_off_fn	endp
;------------------------------------------------------------------------------
;		void	_ds_spk_on/off (void)
;------------------------------------------------------------------------------
_ds_spk_off_fn	proc	near
		call	_ds_beep_off
		call	_ds_sound_off
		call	_ds_stop
		ret
_ds_spk_off_fn	endp

_ds_spk_on_fn	proc	near
		call	_ds_beep_off
		call	_ds_sound_off
		call	_ds_play
		ret
_ds_spk_on_fn	endp
;------------------------------------------------------------------------------
_TEXT		ends
;==============================================================================
		end
