;==============================================================================
;
;	PC-8001 Device Emulator Ver 1.10
;	Copyright (C)1993-97 H.Kanemoto
;
;	This is a free software. You may copy or distribute
;	it without any permissions. But there are NO WARRANTY
;	of use. Entire risk of use is with you.
;
;	External assembler functions for IBM-PC with VC++ 4.2
;	last modified  Jun,16,1997.
;
__BLT4020X_ASM__	equ	1
;==============================================================================
include		n80.mac
;==============================================================================
_TEXT		segment
			.xmm
;------------------------------------------------------------------------------
;		void	_blt4020x (eax=line)
;------------------------------------------------------------------------------
;	ebx = eval_table, text_table ptr	# set before invoke this
;	edi = video ram address
;	esi = pattern address
;	ebp = original font address
;------------------------------------------------------------------------------
		public	_blt4020x
_blt4020x	proc	near
		cmp	eax,20
		jb	@f
		ret
@@:		mov	edi,_n80win32._vram_addr
		add	edi,_n80win32._vtbl_vram20[eax*4]
		mov	ebp,offset FLAT:_n80device._fnt
		mov	ecx,40
_blt4020_0:	push	ebp
		push	ebx
		push	ecx
;;;;;;;;;;;;;;;;
		mov	al,[ebx]	; PAC
		mov	ah,[ebx+80]	; 8bit-ascii code

		mov	cl,al		; color -> pattern_table
		and	cl,07h
		movzx	esi,cl
		mov	esi,_n80win32._vtbl_patt40[esi*4]

		movzx	edx,ah		; ascii -> font address
		test	al,40h		; check secret attr
		jz		_blt4020_9
		mov	ah,20h			; treat secret as ascii code space
		movzx	edx,ah
		jmp	@f
_blt4020_9:		test	al,10h
		jz	_blt4020_1
		add	edx,256
		jmp	@f
_blt4020_1:	cmp	byte ptr _n80device._pcg_mode,0
		je	@f
		add	edx,512
@@:		shl	edx,3
		add	ebp,edx

		mov	cl,al
		test	al,20h		; branch by reverse bit
		jnz	@f
		call	_blt4020nx
		jmp	_blt4020_2
@@:		call	_blt4020rx
_blt4020_2:	nop
;;;;;;;;;;;;;;;;
		pop	ecx
		pop	ebx
		pop	ebp
		add	ebx,2
		loop	_blt4020_0
;		emms
		ret
_blt4020x	endp
;------------------------------------------------------------------------------
;		void	_blt4020nx
;------------------------------------------------------------------------------
_blt4020nx	proc	near
		push	edi
		mov	edx,_n80win32._vram_lpitch

;		pxor	mm0,mm0
;		movq	[edi],mm0
;		movq	[edi+8],mm0
;		add	edi,edx
;		movq	[edi],mm0
;		movq	[edi+8],mm0
;		add	edi,edx
		movdqa	xmm1,[esi+255*16]
		pxor	xmm0,xmm0
		test	cl,08h		; upper line check
		jnz	uprln1
		movdqa	[edi],xmm0
		add	edi,edx
		movdqa	[edi],xmm0
		jmp	@f
uprln1:	movdqu	[edi],xmm1
		add	edi,edx
		movdqu	[edi],xmm0
@@:		add	edi,edx

		_trn40x
		_trn40x
		_trn40x
		_trn40x
		_trn40x
		_trn40x
		_trn40x
		_trn40x

;		pxor	mm0,mm0
;		movq	[edi],mm0
;		movq	[edi+8],mm0
;		add	edi,edx
;		movq	[edi],mm0
;		movq	[edi+8],mm0
		pxor	xmm0,xmm0
		test	cl,80h		; under line check
		jnz	udrln1
		movdqa	[edi],xmm0
		add	edi,edx
		movdqa	[edi],xmm0
		jmp	@f
udrln1:	movdqa	[edi],xmm0
		add	edi,edx
		movdqa	[edi],xmm1

@@:		pop	edi
		add	edi,16
		ret
_blt4020nx	endp
;------------------------------------------------------------------------------
;		void	_blt4020rx
;------------------------------------------------------------------------------
_blt4020rx	proc	near
		push	edi
		mov	edx,_n80win32._vram_lpitch

;		movq	mm0,[esi+255*16]
;		movq	[edi],mm0
;		movq	[edi+8],mm0
;		add	edi,edx
;		movq	[edi],mm0
;		movq	[edi+8],mm0
		movdqa	xmm0,[esi+255*16]
		movdqa	[edi],xmm0
		add	edi,edx
		movdqa	[edi],xmm0
		add	edi,edx

		_trr40x
		_trr40x
		_trr40x
		_trr40x
		_trr40x
		_trr40x
		_trr40x
		_trr40x

;		movq	mm0,[esi+255*16]
;		movq	[edi],mm0
;		movq	[edi+8],mm0
;		add	edi,edx
;		movq	[edi],mm0
;		movq	[edi+8],mm0
		movdqa	xmm0,[esi+255*16]
		movdqa	[edi],xmm0
		add	edi,edx
		movdqa	[edi],xmm0

		pop	edi
		add	edi,16
		ret
_blt4020rx	endp
;------------------------------------------------------------------------------
_TEXT		ends
;==============================================================================
		end
