;==============================================================================
;
;	PC-8001 Device Emulator Ver 1.10
;	Copyright (C)1993-97 H.Kanemoto
;
;	This is a free software. You may copy or distribute
;	it without any permissions. But there are NO WARRANTY
;	of use. Entire risk of use is with you.
;
;	External assembler functions for IBM-PC with VC++ 4.2
;	last modified  Jun,16,1997.
;
__BLT4025X_ASM__	equ	1
;==============================================================================
include		n80.mac
;==============================================================================
_TEXT		segment
			.xmm
;------------------------------------------------------------------------------
;		void	_blt4025x (eax:line)
;------------------------------------------------------------------------------
;	ebx = eval_table, text_table ptr
;	edi = video ram address			# set before calling
;	esi = pattern address
;	ebp = original font address
;------------------------------------------------------------------------------
		public	_blt4025x
_blt4025x	proc	near
		mov	edi,_n80win32._vram_addr
		add	edi,_n80win32._vtbl_vram25[eax*4]
		mov	ebp,offset FLAT:_n80device._fnt
		mov	ecx,40
_blt4025_0:	push	ebp
		push	ebx
		push	ecx
;;;;;;;;;;;;;;;;
		mov	al,[ebx]	; PAC
		mov	ah,[ebx+80]	; 8bit-ascii code

		mov	cl,al		; color -> pattern_table
		and	cl,07h
		movzx	esi,cl
		mov	esi,_n80win32._vtbl_patt40[esi*4]

		movzx	edx,ah		; ascii -> font address
		test	al,40h		; check secret attr
		jz		_blt4025_9
		mov	ah,20h			; treat secret as ascii code space
		movzx	edx,ah
		jmp	@f
_blt4025_9:		test	al,10h
		jz	_blt4025_1
		add	edx,256
		jmp	@f
_blt4025_1:	cmp	byte ptr _n80device._pcg_mode,0
		je	@f
		add	edx,512
@@:		shl	edx,3
		add	ebp,edx

		mov	cl,al
		test	al,20h		; branch by reverse bit
		jnz	@f
		call	_blt4025nx
		jmp	_blt4025_2
@@:		call	_blt4025rx
_blt4025_2:	nop
;;;;;;;;;;;;;;;;
		pop	ecx
		pop	ebx
		pop	ebp
		add	ebx,2
		loop	_blt4025_0
;		emms
		ret
_blt4025x	endp
;------------------------------------------------------------------------------
;		void	_blt4025a
;------------------------------------------------------------------------------
_blt4025nx	proc	near
		push	edi
		mov	edx,_n80win32._vram_lpitch
;		_trn40x
		mov	al,[ebp]
		inc	ebp
		movzx	ebx,al
		shl	ebx,4
		movdqa	xmm0,[esi+ebx]		; font pattern
		movdqa	xmm1,[esi+255*16]	; upper line pattern
		test	cl,08h				; check upper line
		jnz	uprln1
		movdqa	[edi],xmm0
		add	edi,edx
		movdqa	[edi],xmm0
		jmp	@f
uprln1:	movdqa	[edi],xmm1
		add	edi,edx
		movdqa	[edi],xmm0
@@:		add	edi,edx

		_trn40x
		_trn40x
		_trn40x
		_trn40x
		_trn40x
		_trn40x

		mov	al,[ebp]
		inc	ebp
		movzx	ebx,al
		shl	ebx,4
		movdqa	xmm0,[esi+ebx]		; font pattern
		movdqa	xmm1,[esi+255*16]	; upper line pattern
		test	cl,80h				; check under line
		jnz	udrln1
		movdqa	[edi],xmm0
		add	edi,edx
		movdqa	[edi],xmm0
		jmp	@f
udrln1:	movdqa	[edi],xmm0
		add	edi,edx
		movdqa	[edi],xmm1
;		_trn40x
@@:		pop	edi
		add	edi,16
		ret
_blt4025nx	endp
;------------------------------------------------------------------------------
;		void	_blt4025rx
;------------------------------------------------------------------------------
_blt4025rx	proc	near
		push	edi
		mov	edx,_n80win32._vram_lpitch
		_trr40x
		_trr40x
		_trr40x
		_trr40x
		_trr40x
		_trr40x
		_trr40x
		_trr40x
		pop	edi
		add	edi,16
		ret
_blt4025rx	endp
;------------------------------------------------------------------------------
_TEXT		ends
;==============================================================================
		end
