;==============================================================================
;
;	PC-8001 Device Emulator Ver 1.10
;	Copyright (C)1993-97 H.Kanemoto
;
;	This is a free software. You may copy or distribute
;	it without any permissions. But there are NO WARRANTY
;	of use. Entire risk of use is with you.
;
;	External assembler functions for IBM-PC with VC++ 4.2
;	last modified  Jun,16,1997.
;
__BLT8020X_ASM__	equ	1
;==============================================================================
include		n80.mac
;==============================================================================
_TEXT		segment
;------------------------------------------------------------------------------
;		void	_blt8020x (eax=line)
;------------------------------------------------------------------------------
;	ebx = eval_table, text_table ptr	# set before invoke this
;	edi = video ram address
;	esi = pattern address
;	ebp = original font address
;------------------------------------------------------------------------------
		public	_blt8020x
_blt8020x	proc	near
		cmp	eax,20
		jb	@f
		ret
@@:		mov	edi,_n80win32._vram_addr
		add	edi,_n80win32._vtbl_vram20[eax*4]
		mov	ebp,offset FLAT:_n80device._fnt
		mov	ecx,80
_blt8020_0:	push	ebp
		push	ebx
		push	ecx
;;;;;;;;;;;;;;;;
		mov	al,[ebx]	; PAC
		mov	ah,[ebx+80]	; 8bit-ascii code

		mov	cl,al		; color -> pattern_table
		and	cl,07h
		movzx	esi,cl
		mov	esi,_n80win32._vtbl_patt80[esi*4]

		movzx	edx,ah		; ascii -> font address
		test	al,40h		; check secret attr
		jz		_blt8020_9
		mov	ah,20h			; treat secret as ascii code space
		movzx	edx,ah
		jmp	@f
_blt8020_9:	test	al,10h
		jz	_blt8020_1
		add	edx,256
		jmp	@f
_blt8020_1:	cmp	byte ptr _n80device._pcg_mode,0
		je	@f
		add	edx,512
@@:		shl	edx,3
		add	ebp,edx

		mov	cl,al
		test	al,20h		; branch by reverse bit
		jnz	@f
		call	_blt8020nx
		jmp	_blt8020_2
@@:		call	_blt8020rx
_blt8020_2:	nop
;;;;;;;;;;;;;;;;
		pop	ecx
		pop	ebx
		pop	ebp
		inc	ebx
		loop	_blt8020_0
		emms
		ret
_blt8020x	endp
;------------------------------------------------------------------------------
;		void	_blt8020nx
;------------------------------------------------------------------------------
_blt8020nx	proc	near
		push	edi
		mov	edx,_n80win32._vram_lpitch

		movq	mm1,[esi+255*8]
		pxor	mm0,mm0
		test	cl,08h		; upper line check
		jnz	uprln1
		movq	[edi],mm0
		add	edi,edx
		movq	[edi],mm0
		jmp	@f
uprln1:	movq	[edi],mm1
		add	edi,edx
		movq	[edi],mm0
@@:		add	edi,edx

		_trn80x
		_trn80x
		_trn80x
		_trn80x
		_trn80x
		_trn80x
		_trn80x
		_trn80x

		pxor	mm0,mm0
		test	cl,80h		; under line check
		jnz	udrln1
		movq	[edi],mm0
		add	edi,edx
		movq	[edi],mm0
		jmp	@f
udrln1:	movq	[edi],mm0
		add	edi,edx
		movq	[edi],mm1

@@:		pop	edi
		add	edi,8
		ret
_blt8020nx	endp
;------------------------------------------------------------------------------
;		void	_blt8020rx
;------------------------------------------------------------------------------
_blt8020rx	proc	near
		push	edi
		mov	edx,_n80win32._vram_lpitch

		movq	mm0,[esi+255*8]
		movq	[edi],mm0
		add	edi,edx
		movq	[edi],mm0
		add	edi,edx

		_trr80x
		_trr80x
		_trr80x
		_trr80x
		_trr80x
		_trr80x
		_trr80x
		_trr80x

		movq	mm0,[esi+255*8]
		movq	[edi],mm0
		add	edi,edx
		movq	[edi],mm0

		pop	edi
		add	edi,8
		ret
_blt8020rx	endp
;------------------------------------------------------------------------------
_TEXT		ends
;==============================================================================
		end
