;==============================================================================
;
;	PC-8001 Device Emulator Ver 1.10
;	Copyright (C)1993-97 H.Kanemoto
;
;	This is a free software. You may copy or distribute
;	it without any permissions. But there are NO WARRANTY
;	of use. Entire risk of use is with you.
;
;	External assembler functions for IBM-PC with VC++ 4.2
;	last modified  Jun,16,1997.
;
__BLT8025X_ASM__	equ	1
;==============================================================================
include		n80.mac
;==============================================================================
_TEXT		segment
;------------------------------------------------------------------------------
;		void	_blt8025x (eax:line)
;------------------------------------------------------------------------------
;	ebx = eval_table, text_table ptr
;	edi = video ram address			# set before calling
;	esi = pattern address
;	ebp = original font address
;------------------------------------------------------------------------------
		public	_blt8025x
_blt8025x	proc	near
		mov	edi,_n80win32._vram_addr
		add	edi,_n80win32._vtbl_vram25[eax*4]
		mov	ebp,offset FLAT:_n80device._fnt
		mov	ecx,80
_blt8025_0:	push	ebp
		push	ebx
		push	ecx
;;;;;;;;;;;;;;;;
		mov	al,[ebx]	; PAC
		mov	ah,[ebx+80]	; 8bit-ascii code

		mov	cl,al		; color -> pattern_table
		and	cl,07h
		movzx	esi,cl
		mov	esi,_n80win32._vtbl_patt80[esi*4]

		movzx	edx,ah		; ascii -> font address
		test	al,40h		; check secret attr
		jz		_blt8025_9
		mov	ah,20h			; treat secret as ascii code space
		movzx	edx,ah
		jmp	@f
_blt8025_9:	test	al,10h
		jz	_blt8025_1
		add	edx,256
		jmp	@f
_blt8025_1:	cmp	byte ptr _n80device._pcg_mode,0
		je	@f
		add	edx,512
@@:		shl	edx,3
		add	ebp,edx

		mov	cl,al
		test	al,20h		; branch by reverse bit
		jnz	@f
		call	_blt8025nx
		jmp	_blt8025_2
@@:		call	_blt8025rx
_blt8025_2:	nop
;;;;;;;;;;;;;;;;
		pop	ecx
		pop	ebx
		pop	ebp
		inc	ebx
		loop	_blt8025_0
		emms
		ret
_blt8025x	endp
;------------------------------------------------------------------------------
;		void	_blt8025a
;------------------------------------------------------------------------------
_blt8025nx	proc	near
		push	edi
		mov	edx,_n80win32._vram_lpitch
;		_trn80x
		mov	al,[ebp]
		inc	ebp
		movzx	ebx,al
		shl	ebx,3
		movq	mm0,[esi+ebx]
		movq	mm1,[esi+255*8]
		test	cl,08h
		jnz	uprln1
		movq	[edi],mm0
		add	edi,edx
		movq	[edi],mm0
		jmp	@f
uprln1:	movq	[edi],mm1
		add	edi,edx
		movq	[edi],mm0
@@:		add	edi,edx

		_trn80x
		_trn80x
		_trn80x
		_trn80x
		_trn80x
		_trn80x

		mov	al,[ebp]
		inc	ebp
		movzx	ebx,al
		shl	ebx,3
		movq	mm0,[esi+ebx]
		movq	mm1,[esi+255*8]
		test	cl,80h
		jnz	udrln1
		movq	[edi],mm0
		add	edi,edx
		movq	[edi],mm0
		jmp	@f
udrln1:	movq	[edi],mm0
		add	edi,edx
		movq	[edi],mm1
;		_trn80x
@@:		pop	edi
		add	edi,8
		ret
_blt8025nx	endp
;------------------------------------------------------------------------------
;		void	_blt8025rx
;------------------------------------------------------------------------------
_blt8025rx	proc	near
		push	edi
		mov	edx,_n80win32._vram_lpitch
		_trr80x
		_trr80x
		_trr80x
		_trr80x
		_trr80x
		_trr80x
		_trr80x
		_trr80x
		pop	edi
		add	edi,8
		ret
_blt8025rx	endp
;------------------------------------------------------------------------------
_TEXT		ends
;==============================================================================
		end
