;==============================================================================
;
;	PC-8001 Device Emulator Ver 1.00
;	Copyright (C)1993-94 H.Kanemoto
;
;	This is a free software. You may copy or distribute
;	it without any permissions. But there are NO WARRANTY
;	of use. Entire risk of use is with you.
;
;	External assembler functions for IBM-PC with MS-C
;	last modified  Jul,30,1996.
;
__CALENDER_ASM__	equ	1
;==============================================================================
include		n80.mac
public		_regPD1990
extrn		_set_sreg:near
;==============================================================================
_DATA		segment
		even
_dispatch	label	dword
		irpc	n,<01234567>
		dd	OFFSET FLAT:cmd_&n
		endm
_regPD1990	label	byte
_sec		db	?			; uPD1990 40bits shift register
_min		db	?
_hour		db	?
_day		db	?
_mon		db	?
_cstrb		db	?			; ޺޽۰  2:ON,0:OFF
_cclk		db	?			; ޼ĸۯ      4:ON,0:OFF
_shiften	db	?			; shift enable flag 1:EN,0:DIS
_DATA		ends
;==============================================================================
_TEXT		segment
;------------------------------------------------------------------------------
;		void	_init_calender
;------------------------------------------------------------------------------
		public	_initCalender
_initCalender	proc	near
		xor	al,al
		mov	_cstrb,al
		mov	_cclk,al
		mov	_shiften,al
		mov	al,0fh
		mov	_ival._i40,al
		ret
_initCalender	endp
;------------------------------------------------------------------------------
;		void	_time_mode (AH data)
;------------------------------------------------------------------------------
		public	_time_mode
_time_mode	proc	near
		mov	ah,_oval._o40
		mov	bl,ah			; check strobe signal change
		and	bl,2
		mov	al,_cstrb
		and	al,2
		xor	al,bl
		jz	_shift_check
		mov	_cstrb,bl
		and	bl,bl			; check edge type (1 -> 0)
		jnz	_shift_check
		mov	bl,_oval._o10
		and	bl,7
		movzx	ebx,bl
		call	dword ptr _dispatch[ebx*4]	; branch by uPD1990 command
_shift_check:
		mov	ah,_oval._o40
		and	ah,4
		cmp	BYTE PTR _shiften,1
		je	@f
		mov	_cclk,ah
		ret
@@:		mov	al,_cclk		; check cclk signal change
		and	al,4
		xor	al,ah
		jnz	@f
		ret
@@:		mov	_cclk,ah
		and	ah,ah			; check edge type (1 -> 0)
		jz	@f
		ret
@@:		mov	bl,_mon			; shift register
		mov	bh,_oval._o10
		shr	bh,3
		mov	eax,DWORD PTR _sec
		shrd	eax,ebx,1
		shr	bx,1
		mov	_mon,bl
		mov	DWORD PTR _sec,eax
		call	_lsb_set
		ret
;------------------------------------------------------------------------------
;		void	cmd_XX (void)
;------------------------------------------------------------------------------
cmd_0		label	near			; Register Hold Command
		mov	BYTE PTR _shiften,0
		ret
cmd_1		label	near			; Register Shift Command
		mov	BYTE PTR _shiften,1
		ret
cmd_2		label	near			; Time Set Command
		mov	BYTE PTR _shiften,0
		call	_lsb_set
		ret
cmd_3		label	near			; Time Read Command
		mov	BYTE PTR _shiften,0
		call	_set_sreg
		call	_lsb_set
		ret
cmd_4		label	near			; TP=64Hz Command
cmd_5		label	near			; TP=256Hz Command
cmd_6		label	near			; TP=2048Hz Command
cmd_7		label	near			; Test Command
		ret
_time_mode	endp
;------------------------------------------------------------------------------
;		void	_lsb_set (void)
;------------------------------------------------------------------------------
_lsb_set	proc	near
		mov	al,_ival._i40
		and	al,0efh			; clear DATA IN bit
		mov	ah,_sec			; copy LSB of 40bit shift reg
		shr	ah,1
		jnc	@f
		or	al,10h
@@:		mov	_ival._i40,al
		ret
_lsb_set	endp
;------------------------------------------------------------------------------
_TEXT		ends
;==============================================================================
		end
