;==============================================================================
;
;	PC-8001 Device Emulator for Win32 Ver 1.10
;	Copyright (C)1997 H.Kanemoto
;
;	This is a free software. You may copy or distribute
;	it without any permissions. But there are NO WARRANTY
;	of use. Entire risk of use is with you.
;
;	External assembler functions for IBM-PC with VC++ 4.0
;	last modified  Jun,15,1997.
;
;	⑫FCRTC (uPD3301) ւ̃R}hB
;	      20/25 LINE ؂ւAJ[\
;
__CRTC_ASM__	equ	1
;==============================================================================
include		n80.mac
public		_n80_scrn_mode,_n80_color_mode
public		_n80_width_mode,_n80_line_mode
public		_attr_reverse
_NONE		equ	0
_OCW1		equ	1
_OCW5		equ	5
;==============================================================================
_DATA		segment
		even
_dispatch	label	dword
		irpc	h,<12345678>
		dd	offset FLAT:_ocw&h&_cmd
		endm

_n80_scrn_mode	dd	0	; 0:40/20, 1:40/25, 2:80/20, 3:80/25
_n80_color_mode	db	1	; color mode		0:F, 1:
_n80_width_mode	db	0	; 80/40 colmun mode  	0:40, 1:80
_n80_line_mode	db	1	; 20/25 line mode	0:20, 1:25
_attr_reverse	db	0	; attribute color reverse mode flag
_param_count	dw	0	; amount of params already accepted.
_prev_cmd	db	0	; current command which is waiting for params
_DATA		ends
;==============================================================================
_TEXT		segment
;------------------------------------------------------------------------------
;		void	__reset_crtc (void)
;------------------------------------------------------------------------------
		public	__reset_crtc
__reset_crtc	proc	near
		xor	ax,ax
		mov	_prev_cmd,al			; no command issued
		ret
__reset_crtc	endp
;------------------------------------------------------------------------------
;		void	_crtc_cmd (AH:cmd)
;------------------------------------------------------------------------------
		public	__n80_crtc_cmd
__n80_crtc_cmd	proc	near
		push	ebp
		mov	ebp,esp
		push	esi
		push	edi
		push	ebx

		mov	eax,[ebp+8]
		mov	ah,al
		call	_crtc_cmd

		pop		ebx
		pop		edi
		pop		esi
		pop		ebp
		ret
__n80_crtc_cmd	endp

		public	_crtc_cmd
_crtc_cmd	proc	near
		movzx	ebx,ah
		and	bl,0e0h
		shr	ebx,3
		jmp	dword ptr _dispatch[ebx]	; branch by command
		nop
_ocw1_cmd	label	near
		mov	byte ptr _prev_cmd,_OCW1
		mov	word ptr _param_count,0
		ret
_ocw2_cmd	label	near
		test	ah,1
		setnz	byte ptr _attr_reverse
		call	__attr_invalid
		ret
_ocw5_cmd	label	near
		mov	byte ptr _prev_cmd,_OCW5
		mov	word ptr _param_count,0
		test	ah,1
		jnz	@f
		call	_cur_disable
		ret
@@:		call	_cur_enable
		ret

_ocw3_cmd	label	near
_ocw4_cmd	label	near
_ocw6_cmd	label	near
_ocw7_cmd	label	near
_ocw8_cmd	label	near
		mov	byte ptr _prev_cmd,_NONE
		mov	word ptr _param_count,0
		ret
_crtc_cmd	endp
;------------------------------------------------------------------------------
;		void	_crtc_data (AH:data)
;------------------------------------------------------------------------------
		public	__n80_crtc_data
__n80_crtc_data	proc	near
		push	ebp
		mov	ebp,esp
		push	esi
		push	edi
		push	ebx

		mov	eax,[ebp+8]
		mov	ah,al
		call	_crtc_data

		pop		ebx
		pop		edi
		pop		esi
		pop		ebp
		ret
__n80_crtc_data	endp

		public	_crtc_data
_crtc_data	proc	near
		mov	bx,_param_count
		inc	word ptr _param_count
		cmp	byte ptr _prev_cmd,_OCW1
		jne	_crt_ocw5
_crt_ocw1:	cmp	bx,5
		jb	_ocw1_fmt2
		mov	byte ptr _prev_cmd,_NONE
		ret
_ocw1_fmt2:	cmp	bx,1				; line/screen 20 or 25
		jne	@f
		and	ah,7fh
		cmp	ah,25-1
		sete	al
		and	al,01h
		mov	ah,_n80_line_mode
		cmp	ah,al				; no change
		je	@f
		mov	byte ptr _n80_line_mode,al
		mov	ah,_n80_width_mode
		shl	ah,1
		or	al,ah
		movzx	eax,al
		mov	_n80_scrn_mode,eax
		call	__attr_invalid
		call	_chg_bltfunc
@@:		ret

_ocw1_fmt1	label	near
_ocw1_fmt3	label	near
_ocw1_fmt4	label	near
_ocw1_fmt5	label	near
_ocw1_fmt6	label	near
_ocw1_fmt7	label	near
_ocw1_fmt8	label	near
@@:		ret

_crt_ocw5:	cmp	byte ptr _prev_cmd,_OCW5	; cursor position
		jne	@b
@@:		movzx	eax,ah
		cmp	bx,0
		jne	@f
		and	al,7fh
		mov	_n80_cur_newx,al
		ret
@@:		and	al,3fh
		mov	_n80_cur_newy,al
		mov	byte ptr _prev_cmd,_NONE
		call	_cur_move
		ret
_crtc_data	endp
;------------------------------------------------------------------------------
;		void	_width_mode (AH:data)
;------------------------------------------------------------------------------
		public	__n80_width_mode
__n80_width_mode	proc	near
		push	ebp
		mov	ebp,esp
		push	esi
		push	edi
		push	ebx

		mov	eax,[ebp+8]
		mov	ah,al
		call	_width_mode

		pop		ebx
		pop		edi
		pop		esi
		pop		ebp
		ret
__n80_width_mode	endp

public	_width_mode
_width_mode	proc	near
		push	ax
		xor	bx,bx				; ύXtO
		and	ah,01h				; [h
		mov	al,_n80_width_mode
		cmp	ah,al
		je	@f
		mov	byte ptr _n80_width_mode,ah
		shl	ah,1
		mov	al,_n80_line_mode
		or	al,ah
		movzx	eax,al
		mov	_n80_scrn_mode,eax
		call	_chg_bltfunc
		mov	bx,1
@@:
		pop	ax				; J[[h
		and	ah,02h
		shr	ah,1
		mov	al,_n80_color_mode
		cmp	ah,al
		je	@f
		mov	byte ptr _n80_color_mode,ah
		push	bx
		movzx	ebx,ah
		push	ebx
		call	_chg_converter
		add		esp,4
		pop	bx
		mov	bx,1
@@:		cmp	bx,0				; ύXtO`FbN
		je	@f
		call	__attr_invalid
@@:		ret
_width_mode	endp
;------------------------------------------------------------------------------
_TEXT		ends
;==============================================================================
		end
