;==============================================================================
;
;	PC-8001 Device Emulator for Win32 Ver 1.10
;	Copyright (C)1997 H.Kanemoto
;
;	This is a free software. You may copy or distribute
;	it without any permissions. But there are NO WARRANTY
;	of use. Entire risk of use is with you.
;
;	External assembler functions for IBM-PC with VC++ 4.0
;	last modified  Jun,15,1997.
;
;	⑫FJ[\
;
__CURSOR_ASM__	equ	1
;==============================================================================
include		n80.mac
public		_n80_cur_col,_n80_cur_row,_n80_cur_newx,_n80_cur_newy
public		_n80_cur_enable
public		_n80_cur_blink
;==============================================================================
_DATA		segment
		even
_n80_cur_col	db	0	; cursor location x
_n80_cur_row	db	0	; cursor location y
_n80_cur_newx	db	0	; cursor new location x
_n80_cur_newy	db	0	; cursor new location y
_n80_cur_enable	db	1	; cursor enable
_n80_cur_blink	db	1	; cursor blink status
_DATA		ends
;==============================================================================
_TEXT		segment
;------------------------------------------------------------------------------
;		void	_cur_enable (void)
;------------------------------------------------------------------------------
		public	_cur_enable
_cur_enable	proc	near
		mov	byte ptr _n80_cur_enable,1
		ret
_cur_enable	endp
;------------------------------------------------------------------------------
;		void	_cur_disable (void)
;------------------------------------------------------------------------------
		public	_cur_disable
_cur_disable	proc	near
		cmp	byte ptr _n80_cur_enable,0
		je	@f
		mov	byte ptr _n80_cur_enable,0
		mov	bl,_n80_cur_row
		movzx	ebx,bl
		mov	_attrchg[ebx],1
@@:		ret
_cur_disable	endp
;------------------------------------------------------------------------------
;		void	_cur_move (void)
;------------------------------------------------------------------------------
		public	_cur_move
_cur_move	proc	near
		cmp	byte ptr _n80_cur_enable,1
		je	@f
		mov	al,_n80_cur_newy	; renew cursor location
		mov	_n80_cur_row,al
		mov	al,_n80_cur_newx
		cmp	_n80_cur_col,al
		ret

@@:		mov	bl,_n80_cur_row
		cmp	_n80_cur_newy,bl
		je	@f
		movzx	ebx,bl			; operate vertical move
		mov	_attrchg[ebx],1		; erase previouse cursor
		mov	bl,_n80_cur_newy
		mov	_n80_cur_row,bl		; renew new cursor pos
		movzx	ebx,bl
		mov	_attrchg[ebx],1
		mov	byte ptr _n80_cur_blink,1
		mov	bl,_n80_cur_newx
		mov	_n80_cur_col,bl
		ret

@@:		mov	bl,_n80_cur_newy	; operate only holizonal move
		mov	_n80_cur_row,bl		; renew new cursor pos
		mov	al,_n80_cur_newx
		cmp	_n80_cur_col,al
		je	@f
		movzx	ebx,bl
		mov	_attrchg[ebx],1
		mov	byte ptr _n80_cur_blink,1
@@:		mov	_n80_cur_col,al
		ret
_cur_move	endp
;------------------------------------------------------------------------------
_TEXT		ends
;==============================================================================
		end
