;==============================================================================
;
;	PC-8001 Device Emulator for Win32 Ver 1.10
;	Copyright (C)1993-97 H.Kanemoto
;
;	This is a free software. You may copy or distribute
;	it without any permissions. But there are NO WARRANTY
;	of use. Entire risk of use is with you.
;
;	External assembler functions for IBM-PC with VC++ 4.0
;	last modified  Jun,15,1997.
;
__IOPORT_ASM__	equ	1
;==============================================================================
include		n80.mac
public		_oval
public		_ival
;==============================================================================
_DATA		segment
		even
_idispatch	label	dword
		irpc	n,<01234567>
		dd	OFFSET FLAT:_in_&n&0
		endm
_odispatch	label	dword
		irpc	n,<01234567>
		dd	OFFSET FLAT:_out_&n&0
		endm
_oval		OUTVALUE	<>
_ival		INVALUE		<>
_DATA		ends
;==============================================================================
_TEXT		segment
		public __n80_ioread
__n80_ioread	proc	near
		push	ebp
		mov	ebp,esp
		push	esi			; save registers
		push	edi
		push	ebx

		mov	eax,[ebp+8]		; eax = port
		call	_ioread
		movzx	eax,al

		pop	ebx				; restore registers
		pop	edi
		pop	esi
		pop	ebp
		ret
__n80_ioread	endp

		public __n80_iowrite
__n80_iowrite	proc	near
		push	ebp
		mov	ebp,esp
		push	esi			; save registers
		push	edi
		push	ebx

		mov	eax,[ebp+8]		; eax = port
		mov	ebx,[ebp+12]	; ebx = data
		call	_iowrite
		xor	eax,eax

		pop	ebx				; restore registers
		pop	edi
		pop	esi
		pop	ebp
		ret
__n80_iowrite	endp
;------------------------------------------------------------------------------
;		char	_ioread (AL:port)
;------------------------------------------------------------------------------
		public	_ioread
_ioread		proc	near
		test	al,80h			; ignore external I/O access
		jz	@f
		mov	al,0ffh
		ret
@@:		push	esi			; dispatch input operations
		push	edi
		push	ebp
		movzx	ebx,al			; branch by device #
		and	bl,70h
		shr	ebx,2
		and	al,0fh			; specify port address
		call	DWORD PTR _idispatch[ebx]
		pop	ebp
		pop	edi
		pop	esi
		ret
_ioread		endp
;------------------------------------------------------------------------------
_in_00		label	near			; key board input
		cmp	al,9
		ja	SHORT _in_bad_port
		movzx	ebx,al
		mov	al,_n80device._key[ebx]
		ret

_in_20		label	near			; CMT/SIO(i8251)
		and	al,1
		jnz	@f
		call	_cmt_read
		ret
@@:		mov	al,07h
		ret

_in_40		label	near
;		mov	al,0ffh
		mov	al,_ival._i40
		call	_poll_vrtc
		ret

_in_10		label	near			; Not Used
_in_30		label	near			; Not Used
_in_50		label	near			; CRTC(uPD3301)
_in_60		label	near			; DMAC(i8257)
_in_70		label	near			; Not Used
_in_bad_port:	mov	al,0ffh
		ret
;------------------------------------------------------------------------------
;		void	_iowrite (AL:port, BL:data)
;------------------------------------------------------------------------------
		public	_iowrite
_iowrite	proc	near
		test	al,80h			; ignore external I/O access
		jz	@f
		ret
@@:		push	esi			; dispatch output operations
		push	edi
		push	ebp
		mov	ah,bl
		movzx	ebx,al			; branch by device #
		and	bl,70h
		shr	ebx,2
		and	al,0fh			; specify port address
		call	dword ptr _odispatch[ebx]
		pop	ebp
		pop	edi
		pop	esi
		ret
_iowrite	endp
;------------------------------------------------------------------------------
_out_00		label	near			; HAL PCG-8100
		call	_pcg_mode
		ret

_out_10		label	near			; printer/calender
		mov	_oval._o10,ah
		ret

_out_20		label	near			; CMT/SIO(i8251)
		test	al,1
		jnz	@f
		ret
@@:		call	_cmt_command
		ret

_out_30		label	near
		call	_width_mode		; Control #1
		ret

_out_40		label	near			; Control #2 (BEEP)
		mov	_oval._o40,ah		; Strobe (40H)
		call	_time_mode
		test	byte ptr _oval._o40,20h
		jz	@f
		call	_beep_on
		ret
@@:		call	_beep_off
		ret

_out_50		label	near
		test	al,01h			; CRTC (50-51H)
		jne	@f
		call	_crtc_data
		ret
@@:		call	_crtc_cmd
		ret

_out_60		label	near			; DMAC(i8257)
_out_70		label	near			; Not Used
		ret
;------------------------------------------------------------------------------
_TEXT		ends
;==============================================================================
		end
