;==============================================================================
;
;	PC-8001 Device Emulator Ver 1.10
;	Copyright (C)1993-96 H.Kanemoto
;
;	This is a free software. You may copy or distribute
;	it without any permissions. But there are NO WARRANTY
;	of use. Entire risk of use is with you.
;
;	External assembler functions for IBM-PC with VC++ 4.0
;	last modified  Jun,23,1996.
;
__MEMORY_ASM__	equ	1
;==============================================================================
include		n80.mac
public		_n80_memory
public		_rom_area,_ram_area
public		_font_buff,_pcg_buff
extrn		_WriteVram:near
;==============================================================================
_DATA		segment
		even
_n80_memory	label	byte
_rom_area	db	24576 dup (0ffh)
_4th_area	db	8192  dup (7fh)
_ram_area	db	32768 dup (0ffh)
_font_buff	db	4096 dup (0)
_pcg_buff	db	2048 dup (0)
_DATA		ends
;==============================================================================
gxrec		struc
	_BC	dw	?		; general register in word wide
	_DE	dw	?
	_HL	dw	?
	_AF	dw	?
	_BC2	dw	?		; alternate register set
	_DE2	dw	?
	_HL2	dw	?
	_AF2	dw	?
	_IX	dw	?		; index registers
	_IY	dw	?
	_PC	dw	?		; instruction pointer
	_SP	dw	?		; stack pointer
	_T	dd	?		; state in M1 mode
	_W	dd	?		; memory access wait
	_head	dw	?		; headder of current code stream
	_I	db	?		; interrupt vector reg
	_R	db	?		; re-flesh register
	_IFF1	db	?		; interrupt flip flop #1
	_IFF2	db	?		;		      #2
	_HALT	db	?		; if get HALT command
gxrec		ends
extrn		_cpu:gxrec			; z80_thread.cpp
;==============================================================================
_TEXT		segment
;------------------------------------------------------------------------------
;		int	_mxread (int address)
;------------------------------------------------------------------------------
;		public	_mbread
;_mbread		proc	near
;		movzx	ebx,ax			; bx = address
;		mov	al,_n80_memory[ebx]
;		pushf
;		inc	dword ptr _cpu._W
;		popf
;		cbw
;		ret
;_mbread		endp
;
;		public	_mwread
;_mwread		proc	near
;		mov	cx,ax
;		call	_mbread
;		mov	dl,al
;		mov	ax,cx
;		inc	ax
;		call	_mbread
;		mov	dh,al
;		mov	ax,dx
;		ret
;_mwread		endp
;------------------------------------------------------------------------------
;		void	_mxwrite (int address, int data)
;------------------------------------------------------------------------------
;		public	_mbwrite
;_mbwrite	proc	near
;		xchg	ax,bx			; bx = address, al = data
;		movzx	ebx,bx
;		cmp	bh,80h
;		jae	ramwrite
;		ret				; ignore ROM area write
;ramwrite:	pushf
;		inc	dword ptr _cpu._W
;		popf
;		cmp	bh,0f3h			; VRAM area check
;		jae	@f
;		mov	_n80_memory[ebx],al
;		ret
;@@:		cmp	bx,0feb8h
;		jb	@f
;		mov	_n80_memory[ebx],al
;		ret
;@@:		mov	dl,_n80_memory[ebx]	; save prev VRAM value
;		cmp	dl,al			; check whether VRAM is changed or not
;		jne	@f
;		ret
;@@:		pushfd
;		push	ebp
;		push	eax			; pusha is illegal instruction anymore in EM64T?
;		push	ebx
;		push	ecx
;		push	edx
;		push	esi
;		push	edi
;
;		push	eax
;		push	ebx
;		call	_WriteVram		; synchronized writing
;		add	esp,8
;
;		pop	edi
;		pop	esi
;		pop	edx
;		pop	ecx
;		pop	ebx
;		pop	eax
;		pop	ebp
;		popfd
;		ret

;		mov	dl,_n80_memory[ebx]	; save prev VRAM value
;		mov	_n80_memory[ebx],al
;@@:		cmp	dl,al			; if VRAM changed or not
;		jne	@f
;		ret
;@@:		mov	dl,al			; dl = data
;		sub	bx,0f300h
;		mov	ax,bx
;		mov	bl,120
;		div	bl			; ah=width, al=line
;		movzx	ebx,al			; notify text/attr changed
;		mov	byte ptr _attrchg[ebx],1
;		ret
;_mbwrite	endp

;		public	_mwwrite
;_mwwrite	proc	near
;		push	ax
;		push	bx
;		call	_mbwrite		; write low byte
;		pop	bx
;		pop	ax
;		inc	ax			; write hi byte
;		mov	bl,bh
;		call	_mbwrite
;		ret
;_mwwrite	endp
;------------------------------------------------------------------------------
_TEXT		ends
;==============================================================================
		end
