;==============================================================================
;
;	PC-8001 Device Emulator for Win32 Ver 1.10
;	Copyright (C)1993-97 H.Kanemoto
;
;	This is a free software. You may copy or distribute
;	it without any permissions. But there are NO WARRANTY
;	of use. Entire risk of use is with you.
;
;	External assembler functions for IBM-PC with VC++ 4.2
;	last modified  Jun,17,1997.
;
__PCG_ASM__	equ	1
;==============================================================================
include		n80.mac
public		_pcg_freq
public		_n80_pcg_mode
;==============================================================================
_DATA		segment
		even
_n80_pcg_mode	db	0
;_pcgflag	db	0			; 0:OFF(ROM),	1:ON(PCG)
_pcg_freq	dw	19554			; PCG i8253 timmer #2 (adjust)
_timmr_lo	db	0			; PCG i8253  low byte
_timmr_mode	db	0			; PCG i8253 mode register
_timmr_cont	db	0
_pcg_lo		db	0			; PCG RAM  low address
_pcg_hi		db	0			;         high address
_pcg_dat	db	0			; PCG char data
_DATA		ends
;==============================================================================
_TEXT		segment
;------------------------------------------------------------------------------
;		void	__reset_pcg (void)
;------------------------------------------------------------------------------
		public	__reset_pcg
__reset_pcg	proc	near
		xor	ax,ax
		mov	_pcg_dat,al
		mov	_pcg_lo,al
		mov	_timmr_mode,al
		mov	_timmr_cont,al
		mov	_timmr_lo,al
		ret
__reset_pcg	endp
;------------------------------------------------------------------------------
;		void	_pcg_mode (AL:port, AH:data)
;------------------------------------------------------------------------------
		public __n80_pcg_mode
__n80_pcg_mode	proc	near
		push	ebp
		mov		ebp,esp
		push	esi
		push	edi
		push	ebx

		mov	eax,[ebp+8]
		mov	ebx,[ebp+12]
		mov	ah,bl
		call	_pcg_mode

		pop		ebx
		pop		edi
		pop		esi
		pop		ebp
		ret
__n80_pcg_mode	endp

		public	_pcg_mode
_pcg_mode	proc	near
		cmp	al,0fh			; i8253 mode register
		je	_ctc_mode
		cmp	al,0ch			; i8253 timmer #0 counter
		je	_ctc_data
		cmp	al,0
		je	_pcg_p0
		cmp	al,1
		je	_pcg_p1
		cmp	al,2
		je	_pcg_p2
		cmp	al,3
		je	_pcg_p3
		ret
_pcg_p0:	mov	_pcg_dat,ah		; save PCG char data
		ret
_pcg_p1:	mov	_pcg_lo,ah		; PCG RAM low address
		ret
_pcg_p2:	pushad
		test	ah,8			; PCG sound on/off
		jnz	@f
		call	_sound_off
		jmp	short _pcg_trans
@@:		xor	eax,eax
		mov	ax,_pcg_freq
		push	eax
		call	_sound_on
		add	esp,4
_pcg_trans:	popad
		test	ah,10h			; PCG RAM high address
		jnz	@f
		ret
@@:		mov	cl,ah
		and	ah,03h			; pick up A8,A9 line
		mov	_pcg_hi,ah
		mov	al,_pcg_lo
		movzx	ebx,ax
		test	cl,20h
		jz	_move_data
_copy_data:	mov	al,_n80device._fnt[ebx+1024]	; copy data from ROM
		mov	_n80device._pcg[ebx+1024],al
		ret
_move_data:	mov	al,_pcg_dat		; set data to PCG RAM
		mov	_n80device._pcg[ebx+1024],al
		ret

_pcg_p3:	nop
;		pushad
		xor	al,al
		test	ah,3			; PCG ON/OFF
		jz	@f
		mov	al,1
@@:		mov	_n80_pcg_mode,al
;@@:		push	ebx
;		call	_enable_pcg_font
;		add	esp,4
;		popad
		ret
_pcg_mode	endp
;------------------------------------------------------------------------------
;		void	_ctc_mode (AL:port, AH:data)
;------------------------------------------------------------------------------
_ctc_mode	label	near
		test	ah,0c0h			; check ch.#
		jz	@f
		ret
@@:		mov	al,ah			; check load mode
		and	al,30h
		shr	al,4
		cmp	al,3			; word load (L/H)
		jne	@f
		dec	al
		mov	byte ptr _timmr_mode,al
		mov	byte ptr _timmr_cont,al
		ret
@@:		cmp	al,2			; byte load (H)
		jne	@f
		dec	al
		mov	byte ptr _timmr_mode,al
		mov	byte ptr _timmr_cont,al
		mov	byte ptr _timmr_lo,0
		ret
@@:		xor	al,al			; illegal load mode
		mov	byte ptr _timmr_mode,al
		mov	byte ptr _timmr_cont,al
		ret

_ctc_data:	dec	byte ptr _timmr_cont	; load counter data
		js	_ctc_data_exit
		jz	@f
		mov	_timmr_lo,ah		; get low byte
		ret
@@:		mov	al,_timmr_lo		; get high byte
;		cmp	ax,4
;		jbe	@f
;		xor	dx,dx
;		mov	dl,ah
;		mov	ah,al
;		xor	al,al
;		mov	bx,858			; adjust frecuency
;		div	bx			; (4MHz to 1.19MHz)
@@:		mov	_pcg_freq,ax
		mov	bx,ax
		call	_sound_freq_chg
_ctc_data_exit:	mov	al,_timmr_mode
		mov	_timmr_cont,al
		ret
;------------------------------------------------------------------------------
_TEXT		ends
;==============================================================================
		end
