;==============================================================================
;
;	Z80 Emulator Ver 2.00
;	Copyright (C)1993-96 H.Kanemoto
;
;	This is a free software. You may copy or distribute
;	it without any permissions. But there are NO WARRANTY
;	of use. Entire risk of use is with you.
;
;	External assembler functions for VC++ 4.0
;	last modified  Jun,23,1996.
;
;==============================================================================
include		z80em.mac
include		flag.mac
		irpc	h,<0123>
		irpc	l,<0123456789ABCDEF>
public		z80_&h&&l
		endm
		endm
		irpc	h,<0123>
		irpc	l,<0123456789ABCDEF>
extrn		__z80_op_&h&&l:near
		endm
		endm
;==============================================================================
_TEXT		segment
;		assume	CS: _TEXT
;------------------------------------------------------------------------------
;		add routines
;------------------------------------------------------------------------------
;_8080A		proc	near

;add_hl_dd	macro	dd
;		mov	DWORD PTR _cpu._T,12
;		mov	ax,_cpu.&dd
;		add	_cpu._HL,ax
;		pushf
;		_addwf
;		endm

z80_09		label	near			; ADD HL,BC
;		add_hl_dd _BC
		call	__z80_op_09
		ret
z80_19		label	near			; ADD HL,DE
;		add_hl_dd _DE
		call	__z80_op_19
		ret
z80_29		label	near			; ADD HL,HL
;		add_hl_dd _HL
		call	__z80_op_29
		ret
z80_39		label	near			; ADD HL,SP
;		add_hl_dd _SP
		call	__z80_op_39
		ret
;------------------------------------------------------------------------------
;		inc routines
;------------------------------------------------------------------------------
;inc_dd		macro	dd
;		mov	DWORD PTR _cpu._T,7
;		inc	WORD PTR _cpu.&dd
;		ret
;		endm

z80_03		label	near			; INC BC
;		inc_dd	_BC
		call	__z80_op_03
		ret
z80_13		label	near			; INC DE
;		inc_dd	_DE
		call	__z80_op_13
		ret
z80_23		label	near			; INC HL
;		inc_dd	_HL
		call	__z80_op_23
		ret
z80_33		label	near			; INC SP
;		inc_dd	_SP
		call	__z80_op_33
		ret

;inc_r		macro	r
;		mov	DWORD PTR _cpu._T,5
;		bt	DWORD PTR _cpu._F,_CY
;		inc	BYTE PTR _cpu.&r
;		pushf
;		_addf
;		endm

z80_04		label	near			; INC B
;		inc_r	_B
		call	__z80_op_04
		ret
z80_0C		label	near			; INC C
;		inc_r	_C
		call	__z80_op_0C
		ret
z80_14		label	near			; INC D
;		inc_r	_D
		call	__z80_op_14
		ret
z80_1C		label	near			; INC E
;		inc_r	_E
		call	__z80_op_1C
		ret
z80_24		label	near			; INC H
;		inc_r	_H
		call	__z80_op_24
		ret
z80_2C		label	near			; INC L
;		inc_r	_L
		call	__z80_op_2C
		ret
z80_3C		label	near			; INC A
;		inc_r	_A
		call	__z80_op_3C
		ret

z80_34		label	near			; INC (HL)
;		mov	DWORD PTR _cpu._T,12
;		mov	si,_cpu._HL
;		mov	ax,si
;		call	_mbread
;		bt	DWORD PTR _cpu._F,_CY
;		inc	al
;		pushf
;		mov	bl,al
;		mov	ax,si
;		call	_mbwrite
;		_addf
		call	__z80_op_34
		ret
;------------------------------------------------------------------------------
;		dec routines
;------------------------------------------------------------------------------
;dec_dd		macro	dd
;		mov	DWORD PTR _cpu._T,7
;		dec	WORD PTR _cpu.&dd
;		ret
;		endm

z80_0B		label	near			; DEC BC
;		dec_dd	_BC
		call	__z80_op_0B
		ret
z80_1B		label	near			; DEC DE
;		dec_dd	_DE
		call	__z80_op_1B
		ret
z80_2B		label	near			; DEC HL
;		dec_dd	_HL
		call	__z80_op_2B
		ret
z80_3B		label	near			; DEC SP
;		dec_dd	_SP
		call	__z80_op_3B
		ret

;dec_r		macro	r
;		mov	DWORD PTR _cpu._T,5
;		bt	DWORD PTR _cpu._F,_CY
;		dec	_cpu.&r
;		pushf
;		_subf
;		endm

z80_05		label	near			; DEC B
;		dec_r	_B
		call	__z80_op_05
		ret
z80_0D		label	near			; DEC C
;		dec_r	_C
		call	__z80_op_0D
		ret
z80_15		label	near			; DEC D
;		dec_r	_D
		call	__z80_op_15
		ret
z80_1D		label	near			; DEC E
;		dec_r	_E
		call	__z80_op_1D
		ret
z80_25		label	near			; DEC H
;		dec_r	_H
		call	__z80_op_25
		ret
z80_2D		label	near			; DEC L
;		dec_r	_L
		call	__z80_op_2D
		ret
z80_3D		label	near			; DEC A
;		dec_r	_A
		call	__z80_op_3D
		ret

z80_35		label	near			; DEC (HL)
;		mov	DWORD PTR _cpu._T,12
;		mov	si,_cpu._HL
;		mov	ax,si
;		call	_mbread
;		bt	DWORD PTR _cpu._F,_CY
;		dec	al
;		pushf
;		mov	bl,al
;		mov	ax,si
;		call	_mbwrite
;		_subf
		call	__z80_op_35
		ret
;------------------------------------------------------------------------------
;		load routines
;------------------------------------------------------------------------------
;ld_dd_nn	macro	dd
;		mov	DWORD PTR _cpu._T,11
;		_FetchW
;		mov	_cpu.&dd,ax
;		ret
;		endm

z80_01		label	near			; LD BC,nn
;		ld_dd_nn _BC
		call	__z80_op_01
		ret
z80_11		label	near			; LD DE,nn
;		ld_dd_nn _DE
		call	__z80_op_11
		ret
z80_21		label	near			; LD HL,nn
;		ld_dd_nn _HL
		call	__z80_op_21
		ret
z80_31		label	near			; LD SP,nn
;		ld_dd_nn _SP
		call	__z80_op_31
		ret

z80_02		label	near			; LD (BC),A
;		mov	DWORD PTR _cpu._T,8
;		mov	bl,_cpu._A
;		mov	ax,_cpu._BC
;		call	_mbwrite
		call	__z80_op_02
		ret
z80_12		label	near			; LD (DE),A
;		mov	DWORD PTR _cpu._T,8
;		mov	bl,_cpu._A
;		mov	ax,_cpu._DE
;		call	_mbwrite
		call	__z80_op_12
		ret
z80_22		label	near			; LD (nn),HL
;		mov	DWORD PTR _cpu._T,17
;		_FetchW
;		mov	bx,_cpu._HL
;		call	_mwwrite
		call	__z80_op_22
		ret
z80_32		label	near			; LD (nn),A
;		mov	DWORD PTR _cpu._T,14
;		_FetchW
;		mov	bl,_cpu._A
;		call	_mbwrite
		call	__z80_op_32
		ret
z80_0A		label	near			; LD A,(BC)
;		mov	DWORD PTR _cpu._T,8
;		mov	ax,_cpu._BC
;		call	_mbread
;		mov	_cpu._A,al
		call	__z80_op_0A
		ret
z80_1A		label	near			; LD A,(DE)
;		mov	DWORD PTR _cpu._T,8
;		mov	ax,_cpu._DE
;		call	_mbread
;		mov	_cpu._A,al
		call	__z80_op_1A
		ret
z80_2A		label	near			; LD HL,(nn)
;		mov	DWORD PTR _cpu._T,17
;		_FetchW
;		call	_mwread
;		mov	_cpu._HL,ax
		call	__z80_op_2A
		ret
z80_3A		label	near			; LD A,(nn)
;		mov	DWORD PTR _cpu._T,14
;		_FetchW
;		call	_mbread
;		mov	_cpu._A,al
		call	__z80_op_3A
		ret

;ld_r_n		macro	r
;		mov	DWORD PTR _cpu._T,8
;		_FetchB
;		mov	_cpu.&r,al
;		ret
;		endm

z80_06		label	near			; LD B,n
;		ld_r_n	_B
		call	__z80_op_06
		ret
z80_0E		label	near			; LD C,n
;		ld_r_n	_C
		call	__z80_op_0E
		ret
z80_16		label	near			; LD D,n
;		ld_r_n	_D
		call	__z80_op_16
		ret
z80_1E		label	near			; LD E,n
;		ld_r_n	_E
		call	__z80_op_1E
		ret
z80_26		label	near			; LD H,n
;		ld_r_n	_H
		call	__z80_op_26
		ret
z80_2E		label	near			; LD L,n
;		ld_r_n	_L
		call	__z80_op_2E
		ret
z80_3E		label	near			; LD A,n
;		ld_r_n	_A
		call	__z80_op_3E
		ret

z80_36		label	near			; LD (HL),n
;		mov	DWORD PTR _cpu._T,11
;		_FetchB
;		mov	bl,al
;		mov	ax,_cpu._HL
;		call	_mbwrite
		call	__z80_op_36
		ret
;------------------------------------------------------------------------------
;		rotate routines
;------------------------------------------------------------------------------
z80_07		label	near			; RLCA
;		mov	DWORD PTR _cpu._T,5
;		rol	BYTE PTR _cpu._A,1
;		pushf
;		_rxaf
		call	__z80_op_07
		ret

z80_0F		label	near			; RRCA
;		mov	DWORD PTR _cpu._T,5
;		ror	BYTE PTR _cpu._A,1
;		pushf
;		_rxaf
		call	__z80_op_0F
		ret

z80_17		label	near			; RLA
;		mov	DWORD PTR _cpu._T,5
;		bt	DWORD PTR _cpu._F,_CY
;		rcl	BYTE PTR _cpu._A,1
;		pushf
;		_rxaf
		call	__z80_op_17
		ret

z80_1F		label	near			; RRA
;		mov	DWORD PTR _cpu._T,5
;		bt	DWORD PTR _cpu._F,_CY
;		rcr	BYTE PTR _cpu._A,1
;		pushf
;		_rxaf
		call	__z80_op_1F
		ret
;------------------------------------------------------------------------------
;		jump routines
;------------------------------------------------------------------------------
z80_10		label	near			; DJNZ e
;		_FetchB
;		dec	BYTE PTR _cpu._B
;		jz	@f
;		add	bp,ax
;		mov	_cpu._PC,bp
;		mov	DWORD PTR _cpu._T,14
;		ret
;@@:		mov	DWORD PTR _cpu._T,8
;		ret
		call	__z80_op_10
		ret

z80_18		label	near			; JR e
;		mov	DWORD PTR _cpu._T,13
;		_FetchB
;		add	bp,ax
;		mov	_cpu._PC,bp
;		ret
		call	__z80_op_18
		ret

z80_20		label	near			; JR NZ,e
;		_FetchB
;		test	BYTE PTR _cpu._F,_bZ
;		jnz	@f
;		add	bp,ax
;		mov	_cpu._PC,bp
;		mov	DWORD PTR _cpu._T,13
;		ret
;@@:		mov	DWORD PTR _cpu._T,8
;		ret
		call	__z80_op_20
		ret

z80_28		label	near			; JR Z,e
;		_FetchB
;		test	BYTE PTR _cpu._F,_bZ
;		jz	@f
;		add	bp,ax
;		mov	_cpu._PC,bp
;		mov	DWORD PTR _cpu._T,13
;		ret
;@@:		mov	DWORD PTR _cpu._T,8
;		ret
		call	__z80_op_28
		ret

z80_30		label	near			; JR NC,e
;		_FetchB
;		test	BYTE PTR _cpu._F,_bC
;		jnz	@f
;		add	bp,ax
;		mov	_cpu._PC,bp
;		mov	DWORD PTR _cpu._T,13
;		ret
;@@:		mov	DWORD PTR _cpu._T,8
;		ret
		call	__z80_op_30
		ret

z80_38		label	near			; JR C,e
;		_FetchB
;		test	BYTE PTR _cpu._F,_bC
;		jz	@f
;		add	bp,ax
;		mov	_cpu._PC,bp
;		mov	DWORD PTR _cpu._T,13
;		ret
;@@:		mov	DWORD PTR _cpu._T,8
;		ret
		call	__z80_op_38
		ret
;------------------------------------------------------------------------------
;		misc routines
;------------------------------------------------------------------------------
z80_00		label	near			; NOP
;		mov	DWORD PTR _cpu._T,5
;		ret
		call	__z80_op_00
		ret

z80_08		label	near			; EX AF,AF'
;		mov	DWORD PTR _cpu._T,5
;		mov	ax,_cpu._AF
;		xchg	ax,_cpu._AF2
;		mov	_cpu._AF,ax
;		ret
		call	__z80_op_08
		ret

z80_27		label	near			; DAA
;		mov	DWORD PTR _cpu._T,5
;		mov	al,_cpu._A
;		mov	ah,_cpu._F
;		test	ah,2
;		jnz	@f
;		sahf
;		daa
;		jmp	SHORT daa_exit
;@@:		sahf
;		das
;daa_exit:	pushf
;		mov	_cpu._A,al
;		_daaf
		call	__z80_op_27
		ret

z80_2F		label	near			; CPL
;		mov	DWORD PTR _cpu._T,5
;		not	BYTE PTR _cpu._A
;		or	BYTE PTR _cpu._F,12h
;		ret
		call	__z80_op_2F
		ret

z80_37		label	near			; SCF
;		mov	DWORD PTR _cpu._T,5
;		or	BYTE PTR _cpu._F,1
;		and	BYTE PTR _cpu._F,0edh
;		ret
		call	__z80_op_37
		ret

z80_3F		label	near			; CCF
;		mov	DWORD PTR _cpu._T,5
;		mov	al,_cpu._F
;		and	al,0edh
;		btc	ax,_CY
;		jnc	@f
;		or	al,10h
;@@:		mov	_cpu._F,al
;		ret
		call	__z80_op_3F
		ret

;_8080A		endp
;------------------------------------------------------------------------------
_TEXT		ends
;==============================================================================
		end
