;==============================================================================
;
;	Z80 Emulator Ver 2.00
;	Copyright (C)1993-96 H.Kanemoto
;
;	This is a free software. You may copy or distribute
;	it without any permissions. But there are NO WARRANTY
;	of use. Entire risk of use is with you.
;
;	External assembler functions for VC++ 4.00
;	last modified  Jun,23,1996.
;
;==============================================================================
include		z80em.mac
include		flag.mac
public		z80_DD,z80_FD
extrn		__z80_op_DD:near
extrn		__z80_op_FD:near
;extrn		XD_CB:near			; see also OP3A.ASM
;------------------------------------------------------------------------------
;		Undefined instructions		; see also OP3B.ASM
;------------------------------------------------------------------------------
;		irpc	h,<245689AB>
;		irpc	l,<45CD>
;extrn		XD_&h&&l:near
;		endm
;		endm
;		irpc	l,<0123789ABF>
;extrn		XD_6&l:near
;		endm
;extrn		XD_26:near,XD_2E:near
;extrn		XD_7C:near,XD_7D:near
;==============================================================================
;_DATA		segment
;		even
;_index_glue	label	dword
;		irpc	h,<0123456789ABCDEF>
;		irpc	l,<0123456789ABCDEF>
;		dd	OFFSET FLAT:XD_&h&&l
;		endm
;		endm
;_DATA		ends
;==============================================================================
_TEXT		segment
;		assume	CS: _TEXT
;------------------------------------------------------------------------------
;		void	z80_DD/FD (void)
;------------------------------------------------------------------------------
_index		proc	near

z80_DD		label	near			; IX
;		mov	esi,OFFSET FLAT:_cpu._IX
;		jmp	SHORT @f
		call __z80_op_DD
		ret
z80_FD		label	near			; IY
;		mov	esi,OFFSET FLAT:_cpu._IY
;@@:		_FetchB
;		movzx	ebx,al
;		jmp	DWORD PTR _index_glue[ebx*4]
		call __z80_op_FD
		ret
;------------------------------------------------------------------------------
;		add/sub routines
;------------------------------------------------------------------------------
add_ix		macro	dd
		mov	DWORD PTR _cpu._T,17
		mov	ax,_cpu.&dd
		add	[esi],ax
		pushf
		_addwf
		endm

XD_09		label	near			; ADD IX,BC, ADD IY,BC
		add_ix	_BC
XD_19		label	near			; ADD IX,DE, ADD IY,DE
		add_ix	_DE
XD_39		label	near			; ADD IX,SP, ADD IY,SP
		add_ix	_SP
XD_29		label	near			; ADD IX,IX, ADD IY,IY
		mov	ax,[esi]
		add	[esi],ax
		pushf
		_addwf


XD_86		label	near			; ADD A,(IX+n)
		mov	DWORD PTR _cpu._T,21
		_Index
		call	_mbread
		add	_cpu._A,al
		pushf
		_addf
XD_8E		label	near			; ADC A,(IX+n)
		mov	DWORD PTR _cpu._T,21
		_Index
		call	_mbread
		bt	DWORD PTR _cpu._F,_CY
		adc	_cpu._A,al
		pushf
		_addf
XD_96		label	near			; SUB A,(IX+n)
		mov	DWORD PTR _cpu._T,21
		_Index
		call	_mbread
		sub	_cpu._A,al
		pushf
		_subf
XD_9E		label	near			; SBC A,(IX+n)
		mov	DWORD PTR _cpu._T,21
		_Index
		call	_mbread
		bt	DWORD PTR _cpu._F,_CY
		sbb	_cpu._A,al
		pushf
		_subf
XD_A6		label	near			; AND A,(IX+n)
		mov	DWORD PTR _cpu._T,21
		_Index
		call	_mbread
		and	_cpu._A,al
		pushf
		_andf
XD_AE		label	near			; XOR A,(IX+n)
		mov	DWORD PTR _cpu._T,21
		_Index
		call	_mbread
		xor	_cpu._A,al
		pushf
		_orf
XD_B6		label	near			; OR A,(IX+n)
		mov	DWORD PTR _cpu._T,21
		_Index
		call	_mbread
		or	_cpu._A,al
		pushf
		_orf
XD_BE		label	near			; CP A,(IX+n)
		mov	DWORD PTR _cpu._T,21
		_Index
		call	_mbread
		cmp	_cpu._A,al
		pushf
		_subf
;------------------------------------------------------------------------------
;		inc/dec routines
;------------------------------------------------------------------------------
XD_23		label	near			; INC IX, INC IY
		mov	DWORD PTR _cpu._T,12
		inc	WORD PTR [esi]
		ret
XD_2B		label	near			; DEC IX, INC IY
		mov	DWORD PTR _cpu._T,12
		dec	WORD PTR [esi]
		ret
XD_34		label	near			; INC (IX+n), INC (IY+n)
		mov	DWORD PTR _cpu._T,25
		_Index
		call	_mbread
		bt	DWORD PTR _cpu._F,_CY
		inc	al
		pushf
		mov	bl,al
		mov	ax,di
		call	_mbwrite
		_addf

XD_35		label	near			; DEC (IX+n), INC (IY+n)
		mov	DWORD PTR _cpu._T,25
		_Index
		call	_mbread
		bt	DWORD PTR _cpu._F,_CY
		dec	al
		pushf
		mov	bl,al
		mov	ax,di
		call	_mbwrite
		_subf
;------------------------------------------------------------------------------
;		load routines
;------------------------------------------------------------------------------
XD_21		label	near			; LD IX,nn/LD IY,nn
		mov	DWORD PTR _cpu._T,16
		_FetchW
		mov	[esi],ax
		ret
XD_22		label	near			; LD (nn),IX/LD (nn),IY
		mov	DWORD PTR _cpu._T,22
		_FetchW
		mov	bx,[esi]
		call	_mwwrite
		ret
XD_2A		label	near			; LD IX,(nn)/LD IY,(nn)
		mov	DWORD PTR _cpu._T,22
		_FetchW
		call	_mwread
		mov	[esi],ax
		ret
XD_36		label	near			; LD (IX+n),n LD (IY+n),n
		mov	DWORD PTR _cpu._T,21
		_Index
		_FetchB
		mov	bl,al
		mov	ax,di
		call	_mbwrite
		ret

ld_r_ix		macro	r
		mov	DWORD PTR _cpu._T,21
		_Index
		call	_mbread
		mov	_cpu.&r,al
		ret
		endm

XD_46		label	near			; LD B,(IX+n) LD B,(IY+n)
		ld_r_ix	_B
XD_4E		label	near			; LD C,(IX+n) LD C,(IY+n)
		ld_r_ix	_C
XD_56		label	near			; LD D,(IX+n) LD D,(IY+n)
		ld_r_ix	_D
XD_5E		label	near			; LD E,(IX+n) LD E,(IY+n)
		ld_r_ix	_E
XD_66		label	near			; LD H,(IX+n) LD H,(IY+n)
		ld_r_ix	_H
XD_6E		label	near			; LD L,(IX+n) LD L,(IY+n)
		ld_r_ix	_L
XD_7E		label	near			; LD A,(IX+n) LD A,(IY+n)
		ld_r_ix	_A

ld_ix_r		macro	r
		mov	DWORD PTR _cpu._T,21
		_Index
		mov	bl,_cpu.&r
		call	_mbwrite
		ret
		endm

XD_70		label	near			; LD (IX+n),B LD (IY+n),B
		ld_ix_r	_B
XD_71		label	near			; LD (IX+n),C LD (IY+n),C
		ld_ix_r	_C
XD_72		label	near			; LD (IX+n),D LD (IY+n),D
		ld_ix_r	_D
XD_73		label	near			; LD (IX+n),E LD (IY+n),E
		ld_ix_r	_E
XD_74		label	near			; LD (IX+n),H LD (IY+n),H
		ld_ix_r	_H
XD_75		label	near			; LD (IX+n),L LD (IY+n),L
		ld_ix_r	_L
XD_77		label	near			; LD (IX+n),A LD (IY+n),A
		ld_ix_r	_A

XD_F9		label	near			; LD SP,IX  LD SP,IY
		mov	DWORD PTR _cpu._T,12
		mov	ax,[esi]
		mov	_cpu._SP,ax
		ret
XD_E3		label	near			; EX (SP),IX  EX (SP),IY
		mov	DWORD PTR _cpu._T,25
		mov	di,_cpu._SP
		mov	ax,di
		call	_mwread
		xchg	ax,[esi]
		mov	bx,ax
		mov	ax,di
		call	_mwwrite
		ret
;------------------------------------------------------------------------------
;		push/pop routines
;------------------------------------------------------------------------------
XD_E5		label	near			; PUSH IX, PUSH IY
		mov	DWORD PTR _cpu._T,17
		mov	bx,[esi]
		_PushW
		ret
XD_E1		label	near			; POP IX, POP IY
		mov	DWORD PTR _cpu._T,16
		_PopW
		mov	[esi],ax
		ret
;------------------------------------------------------------------------------
;		jump routines
;------------------------------------------------------------------------------
XD_E9		label	near			; JP (IX), JP (IY)
		mov	DWORD PTR _cpu._T,10
		mov	bp,[esi]
		mov	_cpu._PC,bp
		ret
;------------------------------------------------------------------------------
;		illegal instructions
;------------------------------------------------------------------------------
		irpc	h,<01F>
		irpc	l,<012345678ABCDEF>
XD_&h&&l	label	near
		endm
		endm
		irpc	l,<078F>
XD_2&l		label	near
		endm
		irpc	l,<012378ABCDEF>
XD_3&l		label	near
		endm
		irpc	h,<4589AB>
		irpc	l,<0123789ABF>
XD_&h&&l	label	near
		endm
		endm
		irpc	l,<689ABF>
XD_7&l		label	near
		endm
		irpc	l,<0123456789ACDEF>
XD_C&l		label	near
		endm
		irpc	l,<0123456789ABCDEF>
XD_D&l		label	near
		endm
		irpc	l,<024678ABCDEF>
XD_E&l		label	near
		endm
		mov	DWORD PTR _cpu._T,5
		mov	BYTE PTR _z80_signal,_EXITBIT
		mov	BYTE PTR _cpu._HALT,_HALTIL
		ret

_index		endp
;------------------------------------------------------------------------------
_TEXT		ends
;==============================================================================
		end
