;==============================================================================
;
;	Z80 Emulator Ver 2.00
;	Copyright (C)1993-96 H.Kanemoto
;
;	This is a free software. You may copy or distribute
;	it without any permissions. But there are NO WARRANTY
;	of use. Entire risk of use is with you.
;
;	External assembler functions for VC++ 4.0
;	last modified  Jun,23,1996.
;
;==============================================================================
include		z80em.mac
include		flag.mac
extrn		__z80_op_ED:near
public		z80_ED
;==============================================================================
;_DATA		segment
;		even
;_misc_glue	label	dword
;		irpc	h,<0123456789ABCDEF>
;		irpc	l,<0123456789ABCDEF>
;		dd	OFFSET FLAT:ED_&h&&l
;		endm
;		endm
;_DATA		ends
;==============================================================================
_TEXT		segment
;		assume	CS: _TEXT
;------------------------------------------------------------------------------
;		void	z80_ED (void)
;------------------------------------------------------------------------------
_misc		proc	near

z80_ED		label	near
;		_FetchB
;		movzx	ebx,al
;		jmp	DWORD PTR _misc_glue[ebx*4]
		call	__z80_op_ED
		ret
;------------------------------------------------------------------------------
;		in/out routines
;------------------------------------------------------------------------------
in_r		macro	r
;		local	in_r_exit
		mov	DWORD PTR _cpu._T,14
		mov	al,_cpu._C
		call	_ioread
		mov	_cpu.&r,al
;		and	al,al			; flag adjust
;		pushf
;		pop	ax
;		and	al,0ech
;		bt	_cpu._F,_CY
;		jnc	in_r_exit
;		or	al,1
;in_r_exit:	mov	_cpu._F,al
		ret
		endm

;ED_40		label	near			; IN B,(C)
;		in_r	_B
;ED_48		label	near			; IN C,(C)
;		in_r	_C
;ED_50		label	near			; IN D,(C)
;		in_r	_D
;ED_58		label	near			; IN E,(C)
;		in_r	_E
;ED_60		label	near			; IN H,(C)
;		in_r	_H
;ED_68		label	near			; IN L,(C)
;		in_r	_L
;ED_78		label	near			; IN A,(C)
;		in_r	_A

out_r		macro	r
		mov	DWORD PTR _cpu._T,14
		mov	bl,_cpu.&r
		mov	al,_cpu._C
		call	_iowrite
		ret
		endm

ED_41		label	near			; OUT (C),B
		out_r	_B
ED_49		label	near			; OUT (C),C
		out_r	_C
ED_51		label	near			; OUT (C),D
		out_r	_D
ED_59		label	near			; OUT (C),E
		out_r	_E
ED_61		label	near			; OUT (C),H
		out_r	_H
ED_69		label	near			; OUT (C),L
		out_r	_L
ED_79		label	near			; OUT (C),A
		out_r	_A
;------------------------------------------------------------------------------
;		add/sub routines
;------------------------------------------------------------------------------
sbc_dd		macro	dd
		mov	DWORD PTR _cpu._T,17
		mov	ax,_cpu.&dd
		bt	DWORD PTR _cpu._F,_CY
		sbb	_cpu._HL,ax
		pushf
		_subf
		endm

ED_42		label	near			; SBC HL,BC
		sbc_dd	_BC
ED_52		label	near			; SBC HL,DE
		sbc_dd	_DE
ED_62		label	near			; SBC HL,HL
		sbc_dd	_HL
ED_72		label	near			; SBC HL,SP
		sbc_dd	_SP

adc_dd		macro	dd
		mov	DWORD PTR _cpu._T,17
		mov	ax,_cpu.&dd
		bt	DWORD PTR _cpu._F,_CY
		adc	_cpu._HL,ax
		pushf
		_addf
		endm

ED_4A		label	near			; ADC HL,BC
		adc_dd	_BC
ED_5A		label	near			; ADC HL,DE
		adc_dd	_DE
ED_6A		label	near			; ADC HL,HL
		adc_dd	_HL
ED_7A		label	near			; ADC HL,SP
		adc_dd	_SP
;------------------------------------------------------------------------------
;		load routines
;------------------------------------------------------------------------------
ld_nn_dd	macro	dd
		mov	DWORD PTR _cpu._T,22
		_FetchW
		mov	bx,_cpu.&dd
		call	_mwwrite
		ret
		endm

ED_43		label	near			; LD (nn),BC
		ld_nn_dd _BC
ED_53		label	near			; LD (nn),DE
		ld_nn_dd _DE
ED_63		label	near			; LD (nn),HL
		ld_nn_dd _HL
ED_73		label	near			; LD (nn),SP
		ld_nn_dd _SP

ld_dd_nn	macro	dd
		mov	DWORD PTR _cpu._T,22
		_FetchW
		call	_mwread
		mov	_cpu.&dd,ax
		ret
		endm

ED_4B		label	near			; LD BC,(nn)
		ld_dd_nn _BC
ED_5B		label	near			; LD DE,(nn)
		ld_dd_nn _DE
ED_6B		label	near			; LD HL,(nn)
		ld_dd_nn _HL
ED_7B		label	near			; LD SP,(nn)
		ld_dd_nn _SP

ED_47		label	near			; LD I,A
		mov	DWORD PTR _cpu._T,11
		mov	al,_cpu._A
		mov	_cpu._I,al
		ret
ED_4F		label	near			; LD R,A
		mov	DWORD PTR _cpu._T,11
		mov	al,_cpu._A
		mov	_cpu._R,al
		ret
ED_57		label	near			; LD A,I
		mov	al,_cpu._I
		jmp	SHORT @f
ED_5F		label	near			; LD A,R
;		xor	bh,bh
		mov	bl,_z80_sysclk
		movzx	ebx,bl
		mov	al,_rreg[ebx]
		mov	_cpu._R,al
@@:		mov	_cpu._A,al
		and	al,al			; flag adjust
		lahf
		and	ah,0e8h
		bt	DWORD PTR _cpu._F,_CY
		jnc	@f
		or	ah,1
@@:		cmp	BYTE PTR _cpu._IFF2,1
		jne	@f
		or	ah,4
@@:		mov	_cpu._F,ah
		mov	DWORD PTR _cpu._T,11
		ret
;------------------------------------------------------------------------------
;		airthmetic routines
;------------------------------------------------------------------------------
;ED_44		label	near			; NEG
;		mov	DWORD PTR _cpu._T,10
;		neg	BYTE PTR _cpu._A
;		pushf
;		_subf
;------------------------------------------------------------------------------
;		system routines
;------------------------------------------------------------------------------
;ED_46		label	near			; IM 0
;ED_56		label	near			; IM 1
;ED_5E		label	near			; IM 2
;		mov	DWORD PTR _cpu._T,10
;		ret
;ED_45		label	near			; RETN
;		mov	al,_cpu._IFF2
;		mov	_cpu._IFF1,al
;		jmp	SHORT @f
;ED_4D		label	near			; RETI
;@@:		_PopW
;		mov	bp,ax
;		mov	_cpu._PC,bp
;		mov	DWORD PTR _cpu._T,16
;		ret
;------------------------------------------------------------------------------
;		4bit rotate routines
;------------------------------------------------------------------------------
ED_67		label	near			; RRD
		mov	DWORD PTR _cpu._T,20
		mov	si,_cpu._HL
		mov	ax,si
		call	_mbread
		mov	ah,_cpu._A
		mov	cl,4
		ror	ax,cl
		ror	ah,cl
		mov	_cpu._A,ah
		mov	bl,al
		mov	ax,si
		call	_mbwrite
		ret

ED_6F		label	near			; RLD
		mov	DWORD PTR _cpu._T,20
		mov	si,_cpu._HL
		mov	ax,si
		call	_mbread
		mov	ah,_cpu._A
		mov	cl,4
		mov	dl,ah
		mov	dh,ah
		shl	ax,cl
		and	dl,0fh
		or	al,dl
		and	ah,0fh
		and	dh,0f0h
		or	ah,dh
		mov	_cpu._A,ah
		mov	bl,al
		mov	ax,si
		call	_mbwrite
		ret
;------------------------------------------------------------------------------
;		block move routines
;------------------------------------------------------------------------------
ED_A0		label	near			; LDI
		mov	ax,_cpu._HL
		inc	WORD PTR _cpu._HL
		call	_mbread
		mov	bl,al
		mov	ax,_cpu._DE
		inc	WORD PTR _cpu._DE
		call	_mbwrite
		jmp	SHORT @f
ED_A8		label	near			; LDD
		mov	ax,_cpu._HL
		dec	WORD PTR _cpu._HL
		call	_mbread
		mov	bl,al
		mov	ax,_cpu._DE
		dec	WORD PTR _cpu._DE
		call	_mbwrite
@@:		mov	al,_cpu._F		; flag adjust
		and	al,0e9h
		dec	WORD PTR _cpu._BC
		jz	@f
		or	al,4
@@:		mov	_cpu._F,al
		mov	DWORD PTR _cpu._T,18
		ret

ED_B0		label	near			; LDIR
		mov	DWORD PTR _cpu._T,0
		push	bp
		mov	bp,_cpu._BC
		mov	di,_cpu._DE
		mov	si,_cpu._HL
@@:		add	DWORD PTR _cpu._T,23
		mov	ax,si
		call	_mbread
		mov	bl,al
		mov	ax,di
		call	_mbwrite
		inc	si
		inc	di
		dec	bp
		jnz	@b
		jmp	SHORT ldxr
ED_B8		label	near			; LDDR
		mov	DWORD PTR _cpu._T,0
		push	bp
		mov	bp,_cpu._BC
		mov	di,_cpu._DE
		mov	si,_cpu._HL
@@:		add	DWORD PTR _cpu._T,23
		mov	ax,si
		call	_mbread
		mov	bl,al
		mov	ax,di
		call	_mbwrite
		dec	si
		dec	di
		dec	bp
		jnz	@b
ldxr:		mov	_cpu._BC,bp
		mov	_cpu._DE,di
		mov	_cpu._HL,si
		and	BYTE PTR _cpu._F,0e9h	; flag adjust
		pop	bp
		sub	DWORD PTR _cpu._T,5	; STATE = 23-5=18 (BC == Zero)
		ret
;------------------------------------------------------------------------------
;		block search routines
;------------------------------------------------------------------------------
ED_A1		label	near			; CPI
		mov	ax,_cpu._HL
		call	_mbread
		cmp	_cpu._A,al
		pushf
		inc	WORD PTR _cpu._HL
		jmp	SHORT @f
ED_A9		label	near			; CPD
		mov	ax,_cpu._HL
		call	_mbread
		cmp	_cpu._A,al
		pushf
		dec	WORD PTR _cpu._HL
@@:		pop	ax			; flag adjust
		and	al,0fah
		or	al,2
		bt	DWORD PTR _cpu._F,_CY
		jnc	@f
		or	al,1
@@:		dec	WORD PTR _cpu._BC
		jz	@f
		or	al,4
@@:		mov	_cpu._F,al
		mov	DWORD PTR _cpu._T,18
		ret

ED_B1		label	near			; CPIR
		mov	DWORD PTR _cpu._T,0
		push	bp
		mov	bp,_cpu._BC
		mov	si,_cpu._HL
@@:		add	DWORD PTR _cpu._T,23
		mov	ax,si
		call	_mbread
		inc	si
		cmp	_cpu._A,al
		pushf
		pop	cx
		je	cpxr_equ
		dec	bp
		jz	cpxr_exit
		jmp	SHORT @b
ED_B9		label	near			; CPDR
		mov	DWORD PTR _cpu._T,0
		push	bp
		mov	bp,_cpu._BC
		mov	si,_cpu._HL
@@:		add	DWORD PTR _cpu._T,23
		mov	ax,si
		call	_mbread
		dec	si
		cmp	_cpu._A,al
		pushf
		pop	cx
		je	cpxr_equ
		dec	bp
		jz	cpxr_exit
		jmp	SHORT @b
cpxr_equ:	and	cl,0fah
		dec	bp
		jz	@f
		or	cl,4
		jmp	SHORT @f
cpxr_exit:	and	cl,0fah
@@:		bt	DWORD PTR _cpu._F,_CY
		jnc	@f
		or	cl,1
@@:		or	cl,2
		mov	_cpu._F,cl
		mov	_cpu._HL,si
		mov	_cpu._BC,bp
		pop	bp
		ret
;------------------------------------------------------------------------------
;		block in/out routines
;------------------------------------------------------------------------------
ED_A2		label	near			; INI
ED_AA		label	near			; IND
ED_B2		label	near			; INIR
ED_BA		label	near			; INDR
ED_A3		label	near			; OUTI
ED_AB		label	near			; OUTD
ED_B3		label	near			; OTIR
ED_BB		label	near			; OTDR
		mov	DWORD PTR _cpu._T,5
		mov	BYTE PTR _z80_signal,_EXITBIT
		mov	BYTE PTR _cpu._HALT,_HALTUI
		ret
;------------------------------------------------------------------------------
;		illegal instructions
;------------------------------------------------------------------------------
		irpc	h,<012389CDEF>
		irpc	l,<0123456789ABCDEF>
ED_&h&&l	label	near
		endm
		endm
		irpc	l,<CE>
ED_4&l		label	near
		endm
		irpc	l,<45CD>
ED_5&l		label	near
		endm
		irpc	l,<456CDE>
ED_6&l		label	near
		endm
		irpc	l,<014567CDEF>
ED_7&l		label	near
		endm
		irpc	h,<AB>
		irpc	l,<4567CDEF>
ED_&h&&l	label	near
		endm
		endm
		mov	DWORD PTR _cpu._T,5
		mov	BYTE PTR _z80_signal,_EXITBIT
		mov	BYTE PTR _cpu._HALT,_HALTIL
		ret
_misc		endp
;------------------------------------------------------------------------------
_TEXT		ends
;==============================================================================
		end
