;==============================================================================
;
;	Z80 Emulator Ver 2.00
;	Copyright (C)1993-96 H.Kanemoto
;
;	This is a free software. You may copy or distribute
;	it without any permissions. But there are NO WARRANTY
;	of use. Entire risk of use is with you.
;
;	External assembler functions for VC++ 4.0
;	last modified  Jun,23,1996.
;
;==============================================================================
include		z80em.mac
include		flag.mac
public		XD_CB				; see also OP2B.ASM
;==============================================================================
_DATA		segment
		even
_dispatch	label	dword
		irpc	h,<0123456789ABCDEF>
		irpc	l,<6E>
		dd	OFFSET FLAT:XX_&h&&l
		endm
		endm
_DATA		ends
;==============================================================================
_TEXT		segment
;		assume	CS: _TEXT
;------------------------------------------------------------------------------
;		void	XD_CB (void)
;------------------------------------------------------------------------------
XD_CB		proc	near
		_Index
		_FetchB
		mov	bl,al
		and	al,7
		cmp	al,6
		je	@f
		mov	DWORD PTR _cpu._T,5
		mov	BYTE PTR _z80_signal,_EXITBIT
		mov	BYTE PTR _cpu._HALT,_HALTIL
		ret
@@:		and	bl,0f8h
		movzx	ebx,bl
		shr	ebx,1
		jmp	DWORD PTR _dispatch[ebx]

XX_36		label	near
		mov	DWORD PTR _cpu._T,5
		mov	BYTE PTR _z80_signal,_EXITBIT
		mov	BYTE PTR _cpu._HALT,_HALTIL
		ret

XX_06		label	near			; RLC (IX+n)
		mov	DWORD PTR _cpu._T,25
		mov	ax,di
		call	_mbread
		rol	al,1
		pushf
		mov	bx,di
		xchg	ax,bx
		call	_mbwrite
		_rxxf
		ret

XX_0E		label	near			; RRC (IX+n)
		mov	DWORD PTR _cpu._T,25
		mov	ax,di
		call	_mbread
		ror	al,1
		pushf
		mov	bx,di
		xchg	ax,bx
		call	_mbwrite
		_rxxf
		ret

XX_16		label	near			; RL (IX+n)
		mov	DWORD PTR _cpu._T,25
		mov	ax,di
		call	_mbread
		bt	DWORD PTR _cpu._F,_CY
		rcl	al,1
		pushf
		mov	bx,di
		xchg	ax,bx
		call	_mbwrite
		_rxxf
		ret

XX_1E		label	near			; RR (IX+n)
		mov	DWORD PTR _cpu._T,25
		mov	ax,di
		call	_mbread
		bt	DWORD PTR _cpu._F,_CY
		rcr	al,1
		pushf
		mov	bx,di
		xchg	ax,bx
		call	_mbwrite
		_rxxf
		ret

XX_26		label	near			; SLA (IX+n)
		mov	DWORD PTR _cpu._T,25
		mov	ax,di
		call	_mbread
		sal	al,1
		pushf
		mov	bx,di
		xchg	ax,bx
		call	_mbwrite
		_shxf
		ret

XX_2E		label	near			; SRA (IX+n)
		mov	DWORD PTR _cpu._T,25
		mov	ax,di
		call	_mbread
		sar	al,1
		pushf
		mov	bx,di
		xchg	ax,bx
		call	_mbwrite
		_shxf
		ret

XX_3E		label	near			; SRL (IX+n)
		mov	DWORD PTR _cpu._T,25
		mov	ax,di
		call	_mbread
		shr	al,1
		pushf
		mov	bx,di
		xchg	ax,bx
		call	_mbwrite
		_shxf
		ret

ixbit		macro	n
		local	ixbit_exit
		mov	DWORD PTR _cpu._T,22
		mov	ax,di
		call	_mbread
		bt	ax,n
		pushf
		_bitf
		endm

XX_46		label	near			; BIT 0,(IX+n)
		ixbit	0
XX_4E		label	near			; BIT 1,(IX+n)
		ixbit	1
XX_56		label	near			; BIT 2,(IX+n)
		ixbit	2
XX_5E		label	near			; BIT 3,(IX+n)
		ixbit	3
XX_66		label	near			; BIT 4,(IX+n)
		ixbit	4
XX_6E		label	near			; BIT 5,(IX+n)
		ixbit	5
XX_76		label	near			; BIT 6,(IX+n)
		ixbit	6
XX_7E		label	near			; BIT 7,(IX+n)
		ixbit	7

ixres		macro	n
		mov	DWORD PTR _cpu._T,25
		mov	ax,di
		call	_mbread
		btr	ax,n
		mov	bx,di
		xchg	ax,bx
		call	_mbwrite
		ret
		endm

XX_86		label	near			; RES 0,(IX+n)
		ixres	0
XX_8E		label	near			; RES 1,(IX+n)
		ixres	1
XX_96		label	near			; RES 2,(IX+n)
		ixres	2
XX_9E		label	near			; RES 3,(IX+n)
		ixres	3
XX_A6		label	near			; RES 4,(IX+n)
		ixres	4
XX_AE		label	near			; RES 5,(IX+n)
		ixres	5
XX_B6		label	near			; RES 6,(IX+n)
		ixres	6
XX_BE		label	near			; RES 7,(IX+n)
		ixres	7

ixset		macro	n
		mov	DWORD PTR _cpu._T,25
		mov	ax,di
		call	_mbread
		bts	ax,n
		mov	bx,di
		xchg	ax,bx
		call	_mbwrite
		ret
		endm

XX_C6		label	near			; SET 0,(IX+n)
		ixset	0
XX_CE		label	near			; SET 1,(IX+n)
		ixset	1
XX_D6		label	near			; SET 2,(IX+n)
		ixset	2
XX_DE		label	near			; SET 3,(IX+n)
		ixset	3
XX_E6		label	near			; SET 4,(IX+n)
		ixset	4
XX_EE		label	near			; SET 5,(IX+n)
		ixset	5
XX_F6		label	near			; SET 6,(IX+n)
		ixset	6
XX_FE		label	near			; SET 7,(IX+n)
		ixset	7

XD_CB		endp
;------------------------------------------------------------------------------
_TEXT		ends
;==============================================================================
		end
