/**--------------------------------------------------------------------------
 **
 **		NEC PC-8001 Emulator "N80" for Win32/DirectX
 **		--------------------------------------------
 **		Copyright (c) 1993-2010 H.Kanemoto
 **
 **		Z80 Thread
 **
 **		Rev		Date		Descriptions
 **		-----	----------	-----------------------------------------------
 **		1.00	1996/06/27	porting DOS version on WinG
 **		1.20	1997/08/10	porting WinG version on Win32/DirectX
 **		1.30	1998/03/12	
 **		1.43	2007/09/01	XPΉ
 **		1.44	2009/12/15	Vista/7Ή
 **		1.51	2010/01/27	DirectSound OnlyɕύX
 **------------------------------------------------------------------------*/
#include "z80_thread.h"
#include "../n80/n80_directx.h"
#include "../n80/n80_form.h"
#include <math.h>
#include <stdio.h>
/**--------------------------------------------------------------------------
 **		O[oϐ
 **------------------------------------------------------------------------*/
extern DWORD_PTR	affinity;
extern n80_assay	*assay;
extern n80_directx	*dx;
extern n80_form		*form;
extern Z80CPU		cpu;
/**--------------------------------------------------------------------------
 **		RXgN^^fXgN^
 **------------------------------------------------------------------------*/
z80_thread::z80_thread() : icj_thread() {
	m_interlock = 0;
	m_sys_Ts = 0;
	m_z80_paused  = FALSE;
	m_z80_no_wait = FALSE;
	m_dma_load_gain = 20;
	m_render = NULL;
}

z80_thread::~z80_thread() {
	assay->outputLog(TEXT("ENTER ~z80_thread"));
	if (isRunning())
		kill();
	if (m_render != NULL) {
		m_render->postMessage(WM_USER + 1, 0, 0);
		m_render->kill();
		delete m_render;
		m_render = NULL;
	}
	if (m_hevt_sync != NULL) {
		::CloseHandle(m_hevt_sync);
		m_hevt_sync = NULL;
	}
	if (m_hevt_ack != NULL) {
		::CloseHandle(m_hevt_ack);
		m_hevt_ack = NULL;
	}
	if (m_timer != NULL) {
		::CloseHandle(m_timer);
		m_timer = NULL;
	}
	assay->outputLog(TEXT("LEAVE ~z80_thread"));
}
BOOL
z80_thread::init() {
	// Cxg擾
	m_hevt_sync = ::OpenEvent(EVENT_ALL_ACCESS, FALSE, "SYNC");
	m_hevt_ack = ::OpenEvent(EVENT_ALL_ACCESS, FALSE, "ACK");

	// `惌_[
	m_render = new n80_render();

	// Xe[g^C}[
	m_timer = CreateWaitableTimer(NULL, TRUE, NULL);
	if (m_timer == NULL) {
		assay->outputLog(TEXT("Z80 WaitTimer쐬s"));
		return false;
	}
	return true;
}
/**--------------------------------------------------------------------------
 **		Xbh[`{
 **------------------------------------------------------------------------*/
void
z80_thread::enter() {
	// RenderXbh
	m_render->start(false);

	// Thread蓖ProcessorŒ肷
	if (!::SetThreadAffinityMask(::GetCurrentThread(), affinity & 2 ? 2 : 1)) {
		assay->outputLog(TEXT("Z80 ThreadŒ(%d)s"), affinity & 2 ? 2 : 1);
		if (!::SetThreadAffinityMask(::GetCurrentThread(), 1))
			assay->outputLog(TEXT("Z80 ThreadŒ(%d)s"), 1);
		else
			assay->outputLog(TEXT("Z80 ThreadŒ(%d)"), 1);
	} else
		assay->outputLog(TEXT("Z80 ThreadŒ(%d)"), affinity & 2 ? 2 : 1);

	// x^C}[g擾
	LARGE_INTEGER freq, prevTick;
	::QueryPerformanceFrequency(&freq);
	double dbl_performance_freq = (double)freq.QuadPart;
	double dbl_z80_freq = n80device.param.hz;

	// uPD780(Z80)Xe[g݌v
	UINT state_cnt   = 0;
	::Sleep(1000);

	// DirectSoundĐJn
	dx->play();

	::QueryPerformanceCounter(&prevTick);
	// Fetch[vJn
	for (UINT tk = 0, loop_cnt = 0;; ++tk) {
		if ((tk & 0xff) == 0) {
			// ~ṽ`FbN
			#if _MSC_VER <= 1200
			LPVOID prev_interlock = ::InterlockedCompareExchange((PVOID*) &m_interlock, 0, (LPVOID) 1);
			if (prev_interlock == (LPVOID) 1)
			#else
			LONG prev_interlock = ::InterlockedCompareExchange(&m_interlock, 0, 1);
			if (prev_interlock == 1)
			#endif
			{
				// 1) ~CxgM
				::SetEvent(m_hevt_ack);
				m_z80_paused = TRUE;

				// 2) ĊJ҂
				::WaitForSingleObject(m_hevt_sync, INFINITE);

				// 3) IvmF 2)-3)̊ԂɏIv̓Zbg
				if (m_interlock == 2) {
					return;
				}
				// 4) ~̃EFCgJEgNA
				state_cnt = 0;
				m_z80_paused = FALSE;
			}
		}
		// Z80ߎs
		if (n80device.dmac._penarty > 0 && (tk & 3) != 3) {
			if (n80device.dmac._penarty > 10) {
				cpu.r.x.T = 10;
				n80device.dmac._penarty -= 10;
			} else {
				cpu.r.x.T = n80device.dmac._penarty;
				n80device.dmac._penarty = 0;
			}
			cpu.r.x.TwM1 = 0;
			cpu.r.x.W	 = 0;
			cpu.r.x.Wh	 = 0;
		} else {
			if (cpu.step(&cpu)) {
				//_RPT0(_CRT_WARN, "HALT Xbhޏo\n");
				assay->outputLog(TEXT("Z80: HALT Xbhޏo"));
				form->postMessage(WM_USER + 2, (WPARAM) cpu.r.x.head, (LPARAM) cpu.r.x.HALT);
				return;
			}
		}
		// EFCgXe[gɉZ
		if (!m_z80_no_wait)
			cpu.r.x.T += (cpu.r.x.W + cpu.r.x.Wh + cpu.r.x.TwM1);
		else
			cpu.r.x.T += cpu.r.x.TwM1;
		::InterlockedExchangeAdd(&m_sys_Ts, cpu.r.x.T);

		// ^\^C~O
		int vrtc = n80device.vrtc.blanking(cpu.r.x.T);
		if (vrtc == _VRTC_VBBGN) {			// AJn
			;
		} else if (vrtc == _VRTC_VBEND) {	// AI
			m_render->postMessage(WM_USER + 2, 0, 0);	// `˗
		}
		// Beep/PCGԊuXe[gݐ
		n80device.snd.append_ticks(cpu.r.x.T);

		// Xe[g(T)݌v20ms𒴉߂_ŃEFCg
		state_cnt += cpu.r.x.T;
		if (state_cnt >= n80device.param.sync_ticks) {
			// o߃Xe[gPerformanceTickZ
			double dbl_ticks = (dbl_performance_freq * (double)state_cnt) / dbl_z80_freq;
			LONGLONG stateTicks = (LONGLONG)ceil(dbl_ticks);
			LARGE_INTEGER curTick;
			while (1) {
				// ݂Tick擾
				::QueryPerformanceCounter(&curTick);
				LONGLONG passTick = curTick.QuadPart - prevTick.QuadPart;
				if (passTick >= stateTicks) {
					prevTick = curTick;
					break;
				} else {
					double passtime = (stateTicks - passTick) / dbl_performance_freq;
					if (passtime < 0.001)	// 1msȏ̏ꍇTimergp
						continue;
					// (cb - 500us)̃C^[o100nsPʂŐݒ肷
					LARGE_INTEGER interval;
					interval.QuadPart = (LONGLONG)(-10000000 * (passtime - 0.0005));
					if (::SetWaitableTimer(m_timer, &interval, 0, NULL, NULL, FALSE)) {
						::WaitForSingleObject(m_timer, 20);
					}
				}
			}
			// SoundĐ
			dx->requestPlay();
			state_cnt = 0;
		}
	}
}
/**--------------------------------------------------------------------------
 **		iOThreadĂяoj
 **------------------------------------------------------------------------*/
BOOL
z80_thread::sync() {
	// z80 thread`FbN
	if (!isRunning ()) {
		return FALSE;
	}

	// z80 threadɓ~v
	::ResetEvent(m_hevt_sync);
	::ResetEvent(m_hevt_ack);
	::InterlockedExchange(&m_interlock, 1);

	// z80 thread̓mF(Wait Max 5sec)
	if (::WaitForSingleObject(m_hevt_ack, 5000) != WAIT_OBJECT_0) {
		kill();
		return FALSE;
	}
	else
		return TRUE;
}

void
z80_thread::desync() {
	// z80 thread̓~
	::SetEvent(m_hevt_sync);
}
/**--------------------------------------------------------------------------
 **		O
 **------------------------------------------------------------------------*/
void
z80_thread::reset() {
	cpu.reset(&cpu);
}

void
z80_thread::exit() {
	::InterlockedExchange(&m_interlock, 2);
}

void
z80_thread::restart(WORD pc, WORD sp) {
	cpu.r.x.PC = pc;
	cpu.r.x.SP = sp;
}
/**--------------------------------------------------------------------------
 **		WX^擾
 **------------------------------------------------------------------------*/
USHORT
z80_thread::getRegister(int index) {
	return  cpu.r.xr[index];
}
