/**--------------------------------------------------------------------------
 **
 **		NEC PC-8001 Emulator "N80" for Win32/DirectX
 **		--------------------------------------------
 **		Copyright (c) 1993-2010 H.Kanemoto
 **
 **		Z80 Thread
 **
 **		Rev		Date		Descriptions
 **		-----	----------	-----------------------------------------------
 **		1.00	1996/06/27	porting DOS version on WinG
 **		1.20	1997/08/10	porting WinG version on Win32/DirectX
 **		1.30	1998/03/12	
 **		1.43	2007/09/01	XPΉ
 **		1.44	2009/12/15	Vista/7Ή
 **		1.51	2010/01/27	DirectSound OnlyɕύX
 **------------------------------------------------------------------------*/
#ifndef  _Z80_THREAD_H_
#define  _Z80_THREAD_H_
#include "../lib/icj_thread.h"
#include "../n80/n80_directx.h"
#include "../n80/n80_render.h"
#include "z80.h"
/**==========================================================================
 **		Z80XbhNX
 **========================================================================*/
class z80_thread : public icj_thread {
	//-----------------------------------------------------------------------
	//	Xbh֐
	//-----------------------------------------------------------------------
	public:
	virtual BOOL		init();					// 
	virtual BOOL		sync();					// \tgEFA~
	virtual void		desync();				// \tgEFAĊJ
	virtual void		reset();
	virtual void		exit();
	virtual void		restart(WORD pc, WORD sp);
	virtual USHORT		getRegister(int);
	//-----------------------------------------------------------------------
	//	override/helper֐
	//-----------------------------------------------------------------------
	protected:
	virtual void		enter();				// z80 thread start enter
	//-----------------------------------------------------------------------
	//	oϐ
	//-----------------------------------------------------------------------
	private:
	LONG				m_interlock;			// sync start direction value
	HANDLE				m_hevt_sync;			// sync stop request event from primary thread
	HANDLE				m_hevt_ack;				// ack accept response event from z80 thread
	HANDLE				m_timer;				// 20ms interval wait timer
	volatile LONG		m_sys_Ts;				// system clock (T sums with DMA wait)
	BOOL				m_z80_paused;			// z80 cpu clk-cycle is paused or not
	BOOL				m_z80_no_wait;			// z80 no-wait mode
	int					m_dma_load_gain;		// DMA paralty gain rate
	n80_render*			m_render;				// DirectX render thread
	//-----------------------------------------------------------------------
	//	vpeB
	//-----------------------------------------------------------------------
	public:
	virtual LONG		getTs() { return ::InterlockedExchange(&m_sys_Ts, 0); }
	virtual BOOL		getZ80Paused() const { return m_z80_paused; }
	virtual BOOL		getZ80NoWait() const { return m_z80_no_wait; }
	virtual void		setZ80NoWait(BOOL flag) { m_z80_no_wait = flag; }
	virtual int			getDMALoadGain() const { return m_dma_load_gain; }
	virtual void		setDMALoadGain(int v) { m_dma_load_gain = v; }
	//-----------------------------------------------------------------------
	//	RXgN^^fXgN^
	//-----------------------------------------------------------------------
	public:
	z80_thread ();
	virtual ~z80_thread ();
};
#endif //_Z80_THREAD_H_
